## lapack 3.7.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.10)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo" "Coverage")
endif()

project(LAPACK Fortran C)

set(LAPACK_MAJOR_VERSION 3)
set(LAPACK_MINOR_VERSION 7)
set(LAPACK_PATCH_VERSION 1)
set(
  LAPACK_VERSION
  ${LAPACK_MAJOR_VERSION}.${LAPACK_MINOR_VERSION}.${LAPACK_PATCH_VERSION}
  )

include(GNUInstallDirs)

# Updated OSX RPATH settings
# In response to CMake 3.0 generating warnings regarding policy CMP0042,
# the OSX RPATH settings have been updated per recommendations found
# in the CMake Wiki:
#  http://www.cmake.org/Wiki/CMake_RPATH_handling#Mac_OS_X_and_the_RPATH
set(CMAKE_MACOSX_RPATH ON)
set(CMAKE_SKIP_BUILD_RPATH FALSE)
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES ${CMAKE_INSTALL_FULL_LIBDIR} isSystemDir)
if("${isSystemDir}" STREQUAL "-1")
  set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()


# Configure the warning and code coverage suppression file
configure_file(
  "${LAPACK_SOURCE_DIR}/CTestCustom.cmake.in"
  "${LAPACK_BINARY_DIR}/CTestCustom.cmake"
  @ONLY
)

# Add the CMake directory for custon CMake modules
set(CMAKE_MODULE_PATH "${LAPACK_SOURCE_DIR}/CMAKE" ${CMAKE_MODULE_PATH})
include(PreventInSourceBuilds)
include(PreventInBuildInstalls)

if(UNIX)
  if("${CMAKE_Fortran_COMPILER}" MATCHES "ifort")
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fp-model strict")
  endif()
  if("${CMAKE_Fortran_COMPILER}" MATCHES "xlf")
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -qnosave -qstrict=none")
  endif()
# Delete libmtsk in linking sequence for Sun/Oracle Fortran Compiler.
# This library is not present in the Sun package SolarisStudio12.3-linux-x86-bin
  string(REPLACE \;mtsk\; \; CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES "${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES}")
endif()

if(CMAKE_Fortran_COMPILER_ID STREQUAL "Compaq")
  if(WIN32)
    if(CMAKE_GENERATOR STREQUAL "NMake Makefiles")
      get_filename_component(CMAKE_Fortran_COMPILER_CMDNAM ${CMAKE_Fortran_COMPILER} NAME_WE)
      message(STATUS "Using Compaq Fortran compiler with command name ${CMAKE_Fortran_COMPILER_CMDNAM}")
      set(cmd ${CMAKE_Fortran_COMPILER_CMDNAM})
      string(TOLOWER "${cmd}" cmdlc)
      if(cmdlc STREQUAL "df")
        message(STATUS "Assume the Compaq Visual Fortran Compiler is being used")
        set(CMAKE_Fortran_USE_RESPONSE_FILE_FOR_OBJECTS 1)
        set(CMAKE_Fortran_USE_RESPONSE_FILE_FOR_INCLUDES 1)
        #This is a workaround that is needed to avoid forward-slashes in the
        #filenames listed in response files from incorrectly being interpreted as
        #introducing compiler command options
        if(${BUILD_SHARED_LIBS})
          message(FATAL_ERROR "Making of shared libraries with CVF has not been tested.")
        endif()
        set(str "NMake version 9 or later should be used. NMake version 6.0 which is\n")
        set(str "${str}   included with the CVF distribution fails to build Lapack because\n")
        set(str "${str}   the number of source files exceeds the limit for NMake v6.0\n")
        message(STATUS ${str})
        set(CMAKE_Fortran_LINK_EXECUTABLE "LINK /out:<TARGET> <LINK_FLAGS> <LINK_LIBRARIES> <OBJECTS>")
      endif()
    endif()
  endif()
endif()

# Get Python
message(STATUS "Looking for Python greater than 2.6 - ${PYTHONINTERP_FOUND}")
find_package(PythonInterp 2.7) # lapack_testing.py uses features from python 2.7 and greater
if(PYTHONINTERP_FOUND)
  message(STATUS "Using Python version ${PYTHON_VERSION_STRING}")
else()
  message(STATUS "No suitable Python version found, so skipping summary tests.")
endif()
# --------------------------------------------------

set(LAPACK_INSTALL_EXPORT_NAME lapack-targets)

macro(lapack_install_library lib)
  install(TARGETS ${lib}
    EXPORT ${LAPACK_INSTALL_EXPORT_NAME}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  )
endmacro()

set(PKG_CONFIG_DIR ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# --------------------------------------------------
# Testing

enable_testing()
include(CTest)
enable_testing()
# --------------------------------------------------

# Organize output files.  On Windows this also keeps .dll files next
# to the .exe files that need them, making tests easy to run.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${LAPACK_BINARY_DIR}/bin)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${LAPACK_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${LAPACK_BINARY_DIR}/lib)

# --------------------------------------------------
# Check for any necessary platform specific compiler flags
include(CheckLAPACKCompilerFlags)
CheckLAPACKCompilerFlags()

string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_UPPER)
if(${CMAKE_BUILD_TYPE_UPPER} STREQUAL "COVERAGE")
  message(STATUS "Adding coverage")
  find_package(codecov)
endif()

# --------------------------------------------------
# Check second function

include(CheckTimeFunction)
set(TIME_FUNC NONE ${TIME_FUNC})
CHECK_TIME_FUNCTION(NONE TIME_FUNC)
CHECK_TIME_FUNCTION(INT_CPU_TIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME_ TIME_FUNC)
CHECK_TIME_FUNCTION(INT_ETIME TIME_FUNC)
message(STATUS "--> Will use second_${TIME_FUNC}.f and dsecnd_${TIME_FUNC}.f as timing function.")

set(SECOND_SRC ${LAPACK_SOURCE_DIR}/INSTALL/second_${TIME_FUNC}.f)
set(DSECOND_SRC ${LAPACK_SOURCE_DIR}/INSTALL/dsecnd_${TIME_FUNC}.f)

# By default static library
option(BUILD_SHARED_LIBS "Build shared libraries" OFF)

option(BUILD_TESTING "Build tests" OFF)
message(STATUS "Build tests: ${BUILD_TESTING}")

# deprecated LAPACK and LAPACKE routines
option(BUILD_DEPRECATED "Build deprecated routines" OFF)
message(STATUS "Build deprecated routines: ${BUILD_DEPRECATED}")

# --------------------------------------------------
# Precision to build
# By default all precisions are generated
option(BUILD_SINGLE "Build single precision real" ON)
option(BUILD_DOUBLE "Build double precision real" ON)
option(BUILD_COMPLEX "Build single precision complex" ON)
option(BUILD_COMPLEX16 "Build double precision complex" ON)
message(STATUS "Build single precision real: ${BUILD_SINGLE}")
message(STATUS "Build double precision real: ${BUILD_DOUBLE}")
message(STATUS "Build single precision complex: ${BUILD_COMPLEX}")
message(STATUS "Build double precision complex: ${BUILD_COMPLEX16}")

if(NOT (BUILD_SINGLE OR BUILD_DOUBLE OR BUILD_COMPLEX OR BUILD_COMPLEX16))
  message(FATAL_ERROR "Nothing to build, no precision selected.
  Please enable at least one of these:
  BUILD_SINGLE, BUILD_DOUBLE, BUILD_COMPLEX, BUILD_COMPLEX16.")
endif()

# --------------------------------------------------
# Subdirectories that need to be processed
option(USE_OPTIMIZED_BLAS "Whether or not to use an optimized BLAS library instead of included netlib BLAS" OFF)

# Check the usage of the user provided BLAS libraries
if(BLAS_LIBRARIES)
  include(CheckFortranFunctionExists)
  set(CMAKE_REQUIRED_LIBRARIES ${BLAS_LIBRARIES})
  CHECK_FORTRAN_FUNCTION_EXISTS("dgemm" BLAS_FOUND)
  unset(CMAKE_REQUIRED_LIBRARIES)
  if(BLAS_FOUND)
    message(STATUS "--> BLAS supplied by user is WORKING, will use ${BLAS_LIBRARIES}.")
  else()
    message(ERROR "--> BLAS supplied by user is not WORKING, CANNOT USE ${BLAS_LIBRARIES}.")
    message(ERROR "-->     Will use REFERENCE BLAS (by default)")
    message(ERROR "-->     Or Correct your BLAS_LIBRARIES entry ")
    message(ERROR "-->     Or Consider checking USE_OPTIMIZED_BLAS")
  endif()

# User did not provide a BLAS Library but specified to search for one
elseif(USE_OPTIMIZED_BLAS)
  find_package(BLAS)
endif()

# Neither user specified or optimized BLAS libraries can be used
if(NOT BLAS_FOUND)
  message(STATUS "Using supplied NETLIB BLAS implementation")
  add_subdirectory(BLAS)
  set(BLAS_LIBRARIES blas)
else()
  set(CMAKE_EXE_LINKER_FLAGS
    "${CMAKE_EXE_LINKER_FLAGS} ${BLAS_LINKER_FLAGS}"
    CACHE STRING "Linker flags for executables" FORCE)
  set(CMAKE_MODULE_LINKER_FLAGS
    "${CMAKE_MODULE_LINKER_FLAGS} ${BLAS_LINKER_FLAGS}"
    CACHE STRING "Linker flags for modules" FORCE)
  set(CMAKE_SHARED_LINKER_FLAGS
    "${CMAKE_SHARED_LINKER_FLAGS} ${BLAS_LINKER_FLAGS}"
    CACHE STRING "Linker flags for shared libs" FORCE)
endif()


# --------------------------------------------------
# CBLAS
option(CBLAS "Build CBLAS" OFF)

if(CBLAS)
  add_subdirectory(CBLAS)
endif()

# --------------------------------------------------
# XBLAS

option(USE_XBLAS "Build extended precision (needs XBLAS)" OFF)
if(USE_XBLAS)
  find_library(XBLAS_LIBRARY NAMES xblas)
endif()

option(USE_OPTIMIZED_LAPACK "Whether or not to use an optimized LAPACK library instead of included netlib LAPACK" OFF)

# --------------------------------------------------
# LAPACK
# User did not provide a LAPACK Library but specified to search for one
if(USE_OPTIMIZED_LAPACK)
  find_package(LAPACK)
endif()

# Check the usage of the user provided or automatically found LAPACK libraries
if(LAPACK_LIBRARIES)
  include(CheckFortranFunctionExists)
  set(CMAKE_REQUIRED_LIBRARIES ${LAPACK_LIBRARIES})
  # Check if new routine of 3.4.0 is in LAPACK_LIBRARIES
  CHECK_FORTRAN_FUNCTION_EXISTS("dgeqrt" LATESTLAPACK_FOUND)
  unset(CMAKE_REQUIRED_LIBRARIES)
  if(LATESTLAPACK_FOUND)
    message(STATUS "--> LAPACK supplied by user is WORKING, will use ${LAPACK_LIBRARIES}.")
  else()
    message(ERROR "--> LAPACK supplied by user is not WORKING or is older than LAPACK 3.4.0, CANNOT USE ${LAPACK_LIBRARIES}.")
    message(ERROR "-->     Will use REFERENCE LAPACK (by default)")
    message(ERROR "-->     Or Correct your LAPACK_LIBRARIES entry ")
    message(ERROR "-->     Or Consider checking USE_OPTIMIZED_LAPACK")
  endif()
endif()

# Neither user specified or optimized LAPACK libraries can be used
if(NOT LATESTLAPACK_FOUND)
  message(STATUS "Using supplied NETLIB LAPACK implementation")
  set(LAPACK_LIBRARIES lapack)
  add_subdirectory(SRC)
else()
  set(CMAKE_EXE_LINKER_FLAGS
    "${CMAKE_EXE_LINKER_FLAGS} ${LAPACK_LINKER_FLAGS}"
    CACHE STRING "Linker flags for executables" FORCE)
  set(CMAKE_MODULE_LINKER_FLAGS
    "${CMAKE_MODULE_LINKER_FLAGS} ${LAPACK_LINKER_FLAGS}"
    CACHE STRING "Linker flags for modules" FORCE)
  set(CMAKE_SHARED_LINKER_FLAGS
    "${CMAKE_SHARED_LINKER_FLAGS} ${LAPACK_LINKER_FLAGS}"
    CACHE STRING "Linker flags for shared libs" FORCE)
endif()

if(BUILD_TESTING)
  add_subdirectory(TESTING)
endif()

# --------------------------------------------------
# LAPACKE
option(LAPACKE "Build LAPACKE" OFF)

# LAPACKE has also the interface to some routines from tmglib,
# if LAPACKE_WITH_TMG is selected, we need to add those routines to LAPACKE
option(LAPACKE_WITH_TMG "Build LAPACKE with tmglib routines" OFF)
if(LAPACKE_WITH_TMG)
  set(LAPACKE ON)
endif()
if(BUILD_TESTING OR LAPACKE_WITH_TMG) #already included, avoid double inclusion
  add_subdirectory(TESTING/MATGEN)
endif()

if(LAPACKE)
  add_subdirectory(LAPACKE)
endif()

# --------------------------------------------------
# CPACK Packaging

set(CPACK_PACKAGE_NAME "LAPACK")
set(CPACK_PACKAGE_VENDOR "University of Tennessee, Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "LAPACK- Linear Algebra Package")
set(CPACK_PACKAGE_VERSION_MAJOR 3)
set(CPACK_PACKAGE_VERSION_MINOR 5)
set(CPACK_PACKAGE_VERSION_PATCH 0)
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "LAPACK")
if(WIN32 AND NOT UNIX)

=== BLAS/CMakeLists.txt ===
add_subdirectory(SRC)
if(BUILD_TESTING)
  add_subdirectory(TESTING)
endif()
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/blas.pc.in ${CMAKE_CURRENT_BINARY_DIR}/blas.pc @ONLY)
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/blas.pc
  DESTINATION ${PKG_CONFIG_DIR}
  )

=== BLAS/Makefile ===
include ../make.inc

all: blas

blas:
	$(MAKE) -C SRC

blas_testing: blas
	$(MAKE) -C TESTING run

clean:
	$(MAKE) -C SRC clean
	$(MAKE) -C TESTING clean
cleanobj:
	$(MAKE) -C SRC cleanobj
	$(MAKE) -C TESTING cleanobj
cleanlib:
	$(MAKE) -C SRC cleanlib
cleanexe:
	$(MAKE) -C TESTING cleanexe
cleantest:
	$(MAKE) -C TESTING cleantest

=== CBLAS/Makefile ===
include ../make.inc

all: cblas

cblas: include/cblas_mangling.h
	$(MAKE) -C src

include/cblas_mangling.h: include/cblas_mangling_with_flags.h.in
	cp $< $@

cblas_testing: cblas
	$(MAKE) -C testing run

cblas_example: cblas
	$(MAKE) -C examples

clean:
	$(MAKE) -C src clean
	$(MAKE) -C testing clean
	$(MAKE) -C examples clean
cleanobj:
	$(MAKE) -C src cleanobj
	$(MAKE) -C testing cleanobj
	$(MAKE) -C examples cleanobj
cleanlib:
	$(MAKE) -C src cleanlib
cleanexe:
	$(MAKE) -C testing cleanexe
	$(MAKE) -C examples cleanexe
cleantest:
	$(MAKE) -C testing cleantest

=== LAPACKE/CMakeLists.txt ===
message(STATUS "LAPACKE enable")
enable_language(C)

set(LAPACK_INSTALL_EXPORT_NAME lapacke-targets)

# Create a header file lapacke_mangling.h for the routines called in my C programs
include(FortranCInterface)
## Ensure that the fortran compiler and c compiler specified are compatible
FortranCInterface_VERIFY()
FortranCInterface_HEADER(${LAPACK_BINARY_DIR}/include/lapacke_mangling.h
  MACRO_NAMESPACE "LAPACK_"
  SYMBOL_NAMESPACE "LAPACK_")
if(NOT FortranCInterface_GLOBAL_FOUND OR NOT FortranCInterface_MODULE_FOUND)
  message(WARNING "Reverting to pre-defined include/lapacke_mangling.h")
  configure_file(include/lapacke_mangling_with_flags.h.in
                 ${LAPACK_BINARY_DIR}/include/lapacke_mangling.h)
endif()

if(WIN32 AND NOT UNIX)
  add_definitions(-DHAVE_LAPACK_CONFIG_H -DLAPACK_COMPLEX_STRUCTURE)
  message(STATUS "Windows BUILD")
endif()

get_directory_property(DirDefs COMPILE_DEFINITIONS)

include_directories(include ${LAPACK_BINARY_DIR}/include)
add_subdirectory(include)
add_subdirectory(src)
add_subdirectory(utils)

macro(append_subdir_files variable dirname)
  get_directory_property(holder DIRECTORY ${dirname} DEFINITION ${variable})
  foreach(depfile ${holder})
    list(APPEND ${variable} "${dirname}/${depfile}")
  endforeach()
endmacro()

append_subdir_files(LAPACKE_INCLUDE "include")
append_subdir_files(SOURCES "src")
append_subdir_files(DEPRECATED "src")
append_subdir_files(EXTENDED "src")
append_subdir_files(MATGEN "src")
append_subdir_files(UTILS "utils")

if(BUILD_DEPRECATED)
  list(APPEND SOURCES ${DEPRECATED})
endif()
if(USE_XBLAS)
  list(APPEND SOURCES ${EXTENDED})
endif()
if(LAPACKE_WITH_TMG)
  list(APPEND SOURCES ${MATGEN})
endif()
list(APPEND SOURCES ${UTILS})

add_library(lapacke ${SOURCES})
set_target_properties(
  lapacke PROPERTIES
  LINKER_LANGUAGE C
  VERSION ${LAPACK_VERSION}
  SOVERSION ${LAPACK_MAJOR_VERSION}
  )

if(LAPACKE_WITH_TMG)
  target_link_libraries(lapacke PRIVATE tmglib)
endif()
target_link_libraries(lapacke PRIVATE ${LAPACK_LIBRARIES})

lapack_install_library(lapacke)
install(FILES ${LAPACKE_INCLUDE} ${LAPACK_BINARY_DIR}/include/lapacke_mangling.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

if(BUILD_TESTING)
  add_subdirectory(example)
endif()


configure_file(${CMAKE_CURRENT_SOURCE_DIR}/lapacke.pc.in ${CMAKE_CURRENT_BINARY_DIR}/lapacke.pc @ONLY)
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/lapacke.pc
  DESTINATION ${PKG_CONFIG_DIR}
  )

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/lapacke-config-version.cmake.in
  ${LAPACK_BINARY_DIR}/lapacke-config-version.cmake @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/lapacke-config-build.cmake.in
  ${LAPACK_BINARY_DIR}/lapacke-config.cmake @ONLY)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/lapacke-config-install.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/lapacke-config.cmake @ONLY)
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/lapacke-config.cmake
  ${LAPACK_BINARY_DIR}/lapacke-config-version.cmake
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/lapacke-${LAPACK_VERSION}
  )

install(EXPORT lapacke-targets
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/lapacke-${LAPACK_VERSION})

=== LAPACKE/Makefile ===
##############################################################################
# Copyright (c) 2010, Intel Corp.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#   * Redistributions of source code must retain the above copyright notice,
#     this list of conditions and the following disclaimer.
#   * Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   * Neither the name of Intel Corporation nor the names of its contributors
#     may be used to endorse or promote products derived from this software
#     without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.
##############################################################################
# Contents: Native C interface to LAPACK
# Author: Intel Corporation
# September, 2010
##############################################################################
# Top-level makefile for LAPACKE.
#
# To generate lapacke library type 'make lapacke'
# To make both just type 'make'
#
# To remove lapacke object files type 'make cleanobj'
# To clean all above type 'make clean'
# To clean everything including lapacke library type
# 'make cleanall'
#
include ../make.inc

all: lapacke

lapacke: include/lapacke_mangling.h
	$(MAKE) -C src
	$(MAKE) -C utils

include/lapacke_mangling.h: include/lapacke_mangling_with_flags.h.in
	cp $< $@

lapacke_example: lapacke
	$(MAKE) -C example

clean: cleanlib
	$(MAKE) -C src clean
	$(MAKE) -C utils clean
	$(MAKE) -C example clean
cleanobj:
	$(MAKE) -C src cleanobj
	$(MAKE) -C utils cleanobj
	$(MAKE) -C example cleanobj
cleanlib:
	rm -f ../$(LAPACKELIB)
cleanexe:
	$(MAKE) -C example cleanexe

=== SRC/CMakeLists.txt ===
#######################################################################
#  This is the makefile to create a library for LAPACK.
#  The files are organized as follows:

#       ALLAUX  -- Auxiliary routines called from all precisions
#       SCLAUX  -- Auxiliary routines called from single precision
#       DZLAUX  -- Auxiliary routines called from double precision
#
#       DSLASRC -- Double-single mixed precision real routines called from
#                  single, single-extra and double precision real LAPACK
#                  routines (i.e. from SLASRC, SXLASRC, DLASRC).
#       ZCLASRC -- Double-single mixed precision complex routines called from
#                  single, single-extra and double precision complex LAPACK
#                  routines (i.e. from CLASRC, CXLASRC, ZLASRC).
#
#       SLASRC  -- Single precision real LAPACK routines
#       SXLASRC -- Single precision real LAPACK routines using extra
#                  precision.
#       CLASRC  -- Single precision complex LAPACK routines
#       CXLASRC -- Single precision complex LAPACK routines using extra
#                  precision.
#       DLASRC  -- Double precision real LAPACK routines
#       DXLASRC -- Double precision real LAPACK routines using extra
#                  precision.
#       ZLASRC  -- Double precision complex LAPACK routines
#       ZXLASRC -- Double precision complex LAPACK routines using extra
#                  precision.
#
#    DEPRECATED -- Deprecated routines in all precisions
#
#  ***Note***
#  The functions lsame, second, dsecnd, slamch, and dlamch may have
#  to be installed before compiling the library.  Refer to the
#  installation guide, LAPACK Working Note 41, for instructions.
#
#######################################################################

set(ALLAUX ilaenv.f ieeeck.f lsamen.f iparmq.f iparam2stage.F
   ilaprec.f ilatrans.f ilauplo.f iladiag.f chla_transtype.f
   ../INSTALL/ilaver.f ../INSTALL/lsame.f xerbla.f xerbla_array.f
   ../INSTALL/slamch.f)

set(SCLAUX
   sbdsdc.f
   sbdsqr.f sdisna.f slabad.f slacpy.f sladiv.f slae2.f  slaebz.f
   slaed0.f slaed1.f slaed2.f slaed3.f slaed4.f slaed5.f slaed6.f
   slaed7.f slaed8.f slaed9.f slaeda.f slaev2.f slagtf.f
   slagts.f slamrg.f slanst.f
   slapy2.f slapy3.f slarnv.f
   slarra.f slarrb.f slarrc.f slarrd.f slarre.f slarrf.f slarrj.f
   slarrk.f slarrr.f slaneg.f
   slartg.f slaruv.f slas2.f  slascl.f
   slasd0.f slasd1.f slasd2.f slasd3.f slasd4.f slasd5.f slasd6.f
   slasd7.f slasd8.f slasda.f slasdq.f slasdt.f
   slaset.f slasq1.f slasq2.f slasq3.f slasq4.f slasq5.f slasq6.f
   slasr.f  slasrt.f slassq.f slasv2.f spttrf.f sstebz.f sstedc.f
   ssteqr.f ssterf.f slaisnan.f sisnan.f
   slartgp.f slartgs.f
   ${SECOND_SRC})

set(DZLAUX
   dbdsdc.f
   dbdsqr.f ddisna.f dlabad.f dlacpy.f dladiv.f dlae2.f  dlaebz.f
   dlaed0.f dlaed1.f dlaed2.f dlaed3.f dlaed4.f dlaed5.f dlaed6.f
   dlaed7.f dlaed8.f dlaed9.f dlaeda.f dlaev2.f dlagtf.f
   dlagts.f dlamrg.f dlanst.f
   dlapy2.f dlapy3.f dlarnv.f
   dlarra.f dlarrb.f dlarrc.f dlarrd.f dlarre.f dlarrf.f dlarrj.f
   dlarrk.f dlarrr.f dlaneg.f
   dlartg.f dlaruv.f dlas2.f  dlascl.f
   dlasd0.f dlasd1.f dlasd2.f dlasd3.f dlasd4.f dlasd5.f dlasd6.f
   dlasd7.f dlasd8.f dlasda.f dlasdq.f dlasdt.f
   dlaset.f dlasq1.f dlasq2.f dlasq3.f dlasq4.f dlasq5.f dlasq6.f
   dlasr.f  dlasrt.f dlassq.f dlasv2.f dpttrf.f dstebz.f dstedc.f
   dsteqr.f dsterf.f dlaisnan.f disnan.f
   dlartgp.f dlartgs.f
   ../INSTALL/dlamch.f ${DSECOND_SRC})

set(SLASRC
   sbdsvdx.f sgbbrd.f sgbcon.f sgbequ.f sgbrfs.f sgbsv.f
   sgbsvx.f sgbtf2.f sgbtrf.f sgbtrs.f sgebak.f sgebal.f sgebd2.f
   sgebrd.f sgecon.f sgeequ.f sgees.f  sgeesx.f sgeev.f  sgeevx.f
   sgehd2.f sgehrd.f sgelq2.f sgelqf.f
   sgels.f  sgelsd.f sgelss.f sgelsy.f sgeql2.f sgeqlf.f
   sgeqp3.f sgeqr2.f sgeqr2p.f sgeqrf.f sgeqrfp.f sgerfs.f sgerq2.f sgerqf.f
   sgesc2.f sgesdd.f sgesv.f  sgesvd.f sgesvdx.f sgesvx.f sgetc2.f sgetf2.f
   sgetrf2.f sgetri.f
   sggbak.f sggbal.f
   sgges.f  sgges3.f sggesx.f sggev.f  sggev3.f sggevx.f
   sggglm.f sgghrd.f sgghd3.f sgglse.f sggqrf.f
   sggrqf.f sggsvd3.f sggsvp3.f sgtcon.f sgtrfs.f sgtsv.f
   sgtsvx.f sgttrf.f sgttrs.f sgtts2.f shgeqz.f
   shsein.f shseqr.f slabrd.f slacon.f slacn2.f
   slaein.f slaexc.f slag2.f  slags2.f slagtm.f slagv2.f slahqr.f
   slahr2.f slaic1.f slaln2.f slals0.f slalsa.f slalsd.f
   slangb.f slange.f slangt.f slanhs.f slansb.f slansp.f
   slansy.f slantb.f slantp.f slantr.f slanv2.f
   slapll.f slapmt.f
   slaqgb.f slaqge.f slaqp2.f slaqps.f slaqsb.f slaqsp.f slaqsy.f
   slaqr0.f slaqr1.f slaqr2.f slaqr3.f slaqr4.f slaqr5.f
   slaqtr.f slar1v.f slar2v.f ilaslr.f ilaslc.f
   slarf.f  slarfb.f slarfg.f slarfgp.f slarft.f slarfx.f slarfy.f slargv.f
   slarrv.f slartv.f
   slarz.f  slarzb.f slarzt.f slaswp.f slasy2.f 
   slasyf.f slasyf_rook.f slasyf_rk.f slasyf_aa.f
   slatbs.f slatdf.f slatps.f slatrd.f slatrs.f slatrz.f
   slauu2.f slauum.f sopgtr.f sopmtr.f sorg2l.f sorg2r.f
   sorgbr.f sorghr.f sorgl2.f sorglq.f sorgql.f sorgqr.f sorgr2.f
   sorgrq.f sorgtr.f sorm2l.f sorm2r.f sorm22.f
   sormbr.f sormhr.f sorml2.f sormlq.f sormql.f sormqr.f sormr2.f
   sormr3.f sormrq.f sormrz.f sormtr.f spbcon.f spbequ.f spbrfs.f
   spbstf.f spbsv.f  spbsvx.f
   spbtf2.f spbtrf.f spbtrs.f spocon.f spoequ.f sporfs.f sposv.f
   sposvx.f spotf2.f spotrf2.f spotri.f spstrf.f spstf2.f
   sppcon.f sppequ.f
   spprfs.f sppsv.f  sppsvx.f spptrf.f spptri.f spptrs.f sptcon.f
   spteqr.f sptrfs.f sptsv.f  sptsvx.f spttrs.f sptts2.f srscl.f
   ssbev.f  ssbevd.f ssbevx.f ssbgst.f ssbgv.f  ssbgvd.f ssbgvx.f
   ssbtrd.f sspcon.f sspev.f  sspevd.f sspevx.f sspgst.f
   sspgv.f  sspgvd.f sspgvx.f ssprfs.f sspsv.f  sspsvx.f ssptrd.f
   ssptrf.f ssptri.f ssptrs.f sstegr.f sstein.f sstev.f  sstevd.f sstevr.f
   sstevx.f ssycon.f ssyev.f  ssyevd.f ssyevr.f ssyevx.f ssygs2.f
   ssygst.f ssygv.f  ssygvd.f ssygvx.f ssyrfs.f ssysv.f  ssysvx.f
   ssytd2.f ssytf2.f ssytrd.f ssytrf.f ssytri.f ssytri2.f ssytri2x.f
   ssyswapr.f ssytrs.f ssytrs2.f
   ssyconv.f ssyconvf.f ssyconvf_rook.f
   ssytf2_rook.f ssytrf_rook.f ssytrs_rook.f
   ssytri_rook.f ssycon_rook.f ssysv_rook.f
   ssytf2_rk.f ssytrf_rk.f ssytrs_3.f
   ssytri_3.f ssytri_3x.f ssycon_3.f ssysv_rk.f
   ssysv_aa.f ssytrf_aa.f ssytrs_aa.f
   stbcon.f
   stbrfs.f stbtrs.f stgevc.f stgex2.f stgexc.f stgsen.f
   stgsja.f stgsna.f stgsy2.f stgsyl.f stpcon.f stprfs.f stptri.f
   stptrs.f
   strcon.f strevc.f strevc3.f strexc.f strrfs.f strsen.f strsna.f strsyl.f
   strti2.f strtri.f strtrs.f stzrzf.f sstemr.f
   slansf.f spftrf.f spftri.f spftrs.f ssfrk.f stfsm.f stftri.f stfttp.f
   stfttr.f stpttf.f stpttr.f strttf.f strttp.f
   sgejsv.f sgesvj.f sgsvj0.f sgsvj1.f
   sgeequb.f ssyequb.f spoequb.f sgbequb.f
   sbbcsd.f slapmr.f sorbdb.f sorbdb1.f sorbdb2.f sorbdb3.f sorbdb4.f
   sorbdb5.f sorbdb6.f sorcsd.f sorcsd2by1.f
   sgeqrt.f sgeqrt2.f sgeqrt3.f sgemqrt.f
   stpqrt.f stpqrt2.f stpmqrt.f stprfb.f
   sgelqt.f sgelqt3.f sgemlqt.f
   sgetsls.f sgeqr.f slatsqr.f slamtsqr.f sgemqr.f
   sgelq.f slaswlq.f slamswlq.f sgemlq.f
   stplqt.f stplqt2.f stpmlqt.f
   ssytrd_2stage.f ssytrd_sy2sb.f ssytrd_sb2st.F ssb2st_kernels.f
   ssyevd_2stage.f ssyev_2stage.f ssyevx_2stage.f ssyevr_2stage.f
   ssbev_2stage.f ssbevx_2stage.f ssbevd_2stage.f ssygv_2stage.f)

set(DSLASRC spotrs.f sgetrs.f spotrf.f sgetrf.f)

set(SXLASRC sgesvxx.f sgerfsx.f sla_gerfsx_extended.f sla_geamv.f
   sla_gercond.f sla_gerpvgrw.f ssysvxx.f ssyrfsx.f
   sla_syrfsx_extended.f sla_syamv.f sla_syrcond.f sla_syrpvgrw.f
   sposvxx.f sporfsx.f sla_porfsx_extended.f sla_porcond.f
   sla_porpvgrw.f sgbsvxx.f sgbrfsx.f sla_gbrfsx_extended.f
   sla_gbamv.f sla_gbrcond.f sla_gbrpvgrw.f sla_lin_berr.f slarscl2.f
   slascl2.f sla_wwaddw.f)

set(CLASRC
   cbdsqr.f cgbbrd.f cgbcon.f cgbequ.f cgbrfs.f cgbsv.f  cgbsvx.f
   cgbtf2.f cgbtrf.f cgbtrs.f cgebak.f cgebal.f cgebd2.f cgebrd.f
   cgecon.f cgeequ.f cgees.f  cgeesx.f cgeev.f  cgeevx.f
   cgehd2.f cgehrd.f cgelq2.f cgelqf.f
   cgels.f  cgelsd.f cgelss.f cgelsy.f cgeql2.f cgeqlf.f cgeqp3.f
   cgeqr2.f cgeqr2p.f cgeqrf.f cgeqrfp.f cgerfs.f cgerq2.f cgerqf.f
   cgesc2.f cgesdd.f cgesv.f  cgesvd.f cgesvdx.f
   cgesvj.f cgejsv.f cgsvj0.f cgsvj1.f
   cgesvx.f cgetc2.f cgetf2.f cgetrf2.f
   cgetri.f
   cggbak.f cggbal.f
   cgges.f  cgges3.f cggesx.f cggev.f  cggev3.f cggevx.f
   cggglm.f cgghrd.f cgghd3.f cgglse.f cggqrf.f cggrqf.f
   cggsvd3.f cggsvp3.f
   cgtcon.f cgtrfs.f cgtsv.f  cgtsvx.f cgttrf.f cgttrs.f cgtts2.f chbev.f
   chbevd.f chbevx.f chbgst.f chbgv.f  chbgvd.f chbgvx.f chbtrd.f
   checon.f cheev.f  cheevd.f cheevr.f cheevx.f chegs2.f chegst.f
   chegv.f  chegvd.f chegvx.f cherfs.f chesv.f  chesvx.f chetd2.f
   chetf2.f chetrd.f
   chetrf.f chetri.f chetri2.f chetri2x.f cheswapr.f
   chetrs.f chetrs2.f
   chetf2_rook.f chetrf_rook.f chetri_rook.f
   chetrs_rook.f checon_rook.f chesv_rook.f
   chetf2_rk.f chetrf_rk.f chetri_3.f chetri_3x.f
   chetrs_3.f checon_3.f chesv_rk.f
   chesv_aa.f chetrf_aa.f chetrs_aa.f
   chgeqz.f chpcon.f chpev.f  chpevd.f
   chpevx.f chpgst.f chpgv.f  chpgvd.f chpgvx.f chprfs.f chpsv.f
   chpsvx.f
   chptrd.f chptrf.f chptri.f chptrs.f chsein.f chseqr.f clabrd.f
   clacgv.f clacon.f clacn2.f clacp2.f clacpy.f clacrm.f clacrt.f cladiv.f
   claed0.f claed7.f claed8.f
   claein.f claesy.f claev2.f clags2.f clagtm.f
   clahef.f clahef_rook.f clahef_rk.f clahef_aa.f clahqr.f
   clahr2.f claic1.f clals0.f clalsa.f clalsd.f clangb.f clange.f clangt.f
   clanhb.f clanhe.f
   clanhp.f clanhs.f clanht.f clansb.f clansp.f clansy.f clantb.f
   clantp.f clantr.f clapll.f clapmt.f clarcm.f claqgb.f claqge.f
   claqhb.f claqhe.f claqhp.f claqp2.f claqps.f claqsb.f
   claqr0.f claqr1.f claqr2.f claqr3.f claqr4.f claqr5.f
   claqsp.f claqsy.f clar1v.f clar2v.f ilaclr.f ilaclc.f
   clarf.f  clarfb.f clarfg.f clarfgp.f clarft.f
   clarfx.f clarfy.f clargv.f clarnv.f clarrv.f clartg.f clartv.f
   clarz.f  clarzb.f clarzt.f clascl.f claset.f clasr.f  classq.f
   claswp.f clasyf.f clasyf_rook.f clasyf_rk.f clasyf_aa.f
   clatbs.f clatdf.f clatps.f clatrd.f clatrs.f clatrz.f
   clauu2.f clauum.f cpbcon.f cpbequ.f cpbrfs.f cpbstf.f cpbsv.f
   cpbsvx.f cpbtf2.f cpbtrf.f cpbtrs.f cpocon.f cpoequ.f cporfs.f
   cposv.f  cposvx.f cpotf2.f cpotrf2.f cpotri.f cpstrf.f cpstf2.f
   cppcon.f cppequ.f cpprfs.f cppsv.f  cppsvx.f cpptrf.f cpptri.f cpptrs.f
   cptcon.f cpteqr.f cptrfs.f cptsv.f  cptsvx.f cpttrf.f cpttrs.f cptts2.f
   crot.f   cspcon.f cspmv.f  cspr.f   csprfs.f cspsv.f
   cspsvx.f csptrf.f csptri.f csptrs.f csrscl.f cstedc.f
   cstegr.f cstein.f csteqr.f csycon.f csymv.f
   csyr.f   csyrfs.f csysv.f  csysvx.f csytf2.f csytrf.f csytri.f
   csytri2.f csytri2x.f csyswapr.f
   csytrs.f csytrs2.f
   csyconv.f csyconvf.f csyconvf_rook.f
   csytf2_rook.f csytrf_rook.f csytrs_rook.f
   csytri_rook.f csycon_rook.f csysv_rook.f
   csytf2_rk.f csytrf_rk.f csytrf_aa.f csytrs_3.f csytrs_aa.f
   csytri_3.f csytri_3x.f csycon_3.f csysv_rk.f csysv_aa.f
   ctbcon.f ctbrfs.f ctbtrs.f ctgevc.f ctgex2.f
   ctgexc.f ctgsen.f ctgsja.f ctgsna.f ctgsy2.f ctgsyl.f ctpcon.f
   ctprfs.f ctptri.f
   ctptrs.f ctrcon.f ctrevc.f ctrevc3.f ctrexc.f ctrrfs.f ctrsen.f ctrsna.f
   ctrsyl.f ctrti2.f ctrtri.f ctrtrs.f ctzrzf.f cung2l.f cung2r.f
   cungbr.f cunghr.f cungl2.f cunglq.f cungql.f cungqr.f cungr2.f
   cungrq.f cungtr.f cunm2l.f cunm2r.f cunmbr.f cunmhr.f cunml2.f cunm22.f
   cunmlq.f cunmql.f cunmqr.f cunmr2.f cunmr3.f cunmrq.f cunmrz.f
   cunmtr.f cupgtr.f cupmtr.f icmax1.f scsum1.f cstemr.f
   chfrk.f ctfttp.f clanhf.f cpftrf.f cpftri.f cpftrs.f ctfsm.f ctftri.f
   ctfttr.f ctpttf.f ctpttr.f ctrttf.f ctrttp.f
   cgeequb.f cgbequb.f csyequb.f cpoequb.f cheequb.f
   cbbcsd.f clapmr.f cunbdb.f cunbdb1.f cunbdb2.f cunbdb3.f cunbdb4.f
   cunbdb5.f cunbdb6.f cuncsd.f cuncsd2by1.f
   cgeqrt.f cgeqrt2.f cgeqrt3.f cgemqrt.f
   ctpqrt.f ctpqrt2.f ctpmqrt.f ctprfb.f
   cgelqt.f cgelqt3.f cgemlqt.f
   cgetsls.f cgeqr.f clatsqr.f clamtsqr.f cgemqr.f

=== SRC/Makefile ===
include ../make.inc

#######################################################################
#  This is the makefile to create a library for LAPACK.
#  The files are organized as follows:
#
#       ALLAUX  -- Auxiliary routines called from all precisions
#       SCLAUX  -- Auxiliary routines called from single precision
#       DZLAUX  -- Auxiliary routines called from double precision
#
#       DSLASRC -- Double-single mixed precision real routines called from
#                  single, single-extra and double precision real LAPACK
#                  routines (i.e. from SLASRC, SXLASRC, DLASRC).
#       ZCLASRC -- Double-single mixed precision complex routines called from
#                  single, single-extra and double precision complex LAPACK
#                  routines (i.e. from CLASRC, CXLASRC, ZLASRC).
#
#       SLASRC  -- Single precision real LAPACK routines
#       SXLASRC -- Single precision real LAPACK routines using extra
#                  precision.
#       CLASRC  -- Single precision complex LAPACK routines
#       CXLASRC -- Single precision complex LAPACK routines using extra
#                  precision.
#       DLASRC  -- Double precision real LAPACK routines
#       DXLASRC -- Double precision real LAPACK routines using extra
#                  precision.
#       ZLASRC  -- Double precision complex LAPACK routines
#       ZXLASRC -- Double precision complex LAPACK routines using extra
#                  precision.
#
#    DEPRECATED -- Deprecated routines in all precisions
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  To create or add to the library, enter make
#  followed by one or more of the precisions desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates a library of all four precisions.
#  The library is called
#       lapack.a
#  and is created at the next higher directory level.
#
#  To remove the object files after the library is created, enter
#       make cleanobj
#  On some systems, you can force the source files to be recompiled by
#  entering (for example)
#       make single FRC=FRC
#
#  ***Note***
#  The functions lsame, second, dsecnd, slamch, and dlamch may have
#  to be installed before compiling the library.  Refer to the
#  installation guide, LAPACK Working Note 41, for instructions.
#
#######################################################################

ALLAUX = ilaenv.o ieeeck.o lsamen.o xerbla.o xerbla_array.o iparmq.o iparam2stage.o \
   ilaprec.o ilatrans.o ilauplo.o iladiag.o chla_transtype.o \
   ../INSTALL/ilaver.o ../INSTALL/lsame.o ../INSTALL/slamch.o

SCLAUX = \
   sbdsdc.o \
   sbdsqr.o sdisna.o slabad.o slacpy.o sladiv.o slae2.o  slaebz.o \
   slaed0.o slaed1.o slaed2.o slaed3.o slaed4.o slaed5.o slaed6.o \
   slaed7.o slaed8.o slaed9.o slaeda.o slaev2.o slagtf.o \
   slagts.o slamrg.o slanst.o \
   slapy2.o slapy3.o slarnv.o \
   slarra.o slarrb.o slarrc.o slarrd.o slarre.o slarrf.o slarrj.o \
   slarrk.o slarrr.o slaneg.o \
   slartg.o slaruv.o slas2.o  slascl.o \
   slasd0.o slasd1.o slasd2.o slasd3.o slasd4.o slasd5.o slasd6.o \
   slasd7.o slasd8.o slasda.o slasdq.o slasdt.o \
   slaset.o slasq1.o slasq2.o slasq3.o slasq4.o slasq5.o slasq6.o \
   slasr.o  slasrt.o slassq.o slasv2.o spttrf.o sstebz.o sstedc.o \
   ssteqr.o ssterf.o slaisnan.o sisnan.o \
   slartgp.o slartgs.o \
   ../INSTALL/second_$(TIMER).o

DZLAUX = \
   dbdsdc.o \
   dbdsqr.o ddisna.o dlabad.o dlacpy.o dladiv.o dlae2.o  dlaebz.o \
   dlaed0.o dlaed1.o dlaed2.o dlaed3.o dlaed4.o dlaed5.o dlaed6.o \
   dlaed7.o dlaed8.o dlaed9.o dlaeda.o dlaev2.o dlagtf.o \
   dlagts.o dlamrg.o dlanst.o \
   dlapy2.o dlapy3.o dlarnv.o \
   dlarra.o dlarrb.o dlarrc.o dlarrd.o dlarre.o dlarrf.o dlarrj.o \
   dlarrk.o dlarrr.o dlaneg.o \
   dlartg.o dlaruv.o dlas2.o  dlascl.o \
   dlasd0.o dlasd1.o dlasd2.o dlasd3.o dlasd4.o dlasd5.o dlasd6.o \
   dlasd7.o dlasd8.o dlasda.o dlasdq.o dlasdt.o \
   dlaset.o dlasq1.o dlasq2.o dlasq3.o dlasq4.o dlasq5.o dlasq6.o \
   dlasr.o  dlasrt.o dlassq.o dlasv2.o dpttrf.o dstebz.o dstedc.o \
   dsteqr.o dsterf.o dlaisnan.o disnan.o \
   dlartgp.o dlartgs.o \
   ../INSTALL/dlamch.o ../INSTALL/dsecnd_$(TIMER).o

SLASRC = \
   sbdsvdx.o spotrf2.o sgetrf2.o \
   sgbbrd.o sgbcon.o sgbequ.o sgbrfs.o sgbsv.o \
   sgbsvx.o sgbtf2.o sgbtrf.o sgbtrs.o sgebak.o sgebal.o sgebd2.o \
   sgebrd.o sgecon.o sgeequ.o sgees.o  sgeesx.o sgeev.o  sgeevx.o \
   sgehd2.o sgehrd.o sgelq2.o sgelqf.o \
   sgels.o  sgelsd.o sgelss.o sgelsy.o sgeql2.o sgeqlf.o \
   sgeqp3.o sgeqr2.o sgeqr2p.o sgeqrf.o sgeqrfp.o sgerfs.o \
   sgerq2.o sgerqf.o sgesc2.o sgesdd.o sgesv.o  sgesvd.o sgesvdx.o sgesvx.o \
   sgetc2.o sgetf2.o sgetri.o \
   sggbak.o sggbal.o sgges.o  sgges3.o sggesx.o \
   sggev.o  sggev3.o sggevx.o \
   sggglm.o sgghrd.o sgghd3.o sgglse.o sggqrf.o \
   sggrqf.o sggsvd3.o sggsvp3.o sgtcon.o sgtrfs.o sgtsv.o \
   sgtsvx.o sgttrf.o sgttrs.o sgtts2.o shgeqz.o \
   shsein.o shseqr.o slabrd.o slacon.o slacn2.o \
   slaein.o slaexc.o slag2.o  slags2.o slagtm.o slagv2.o slahqr.o \
   slahr2.o slaic1.o slaln2.o slals0.o slalsa.o slalsd.o \
   slangb.o slange.o slangt.o slanhs.o slansb.o slansp.o \
   slansy.o slantb.o slantp.o slantr.o slanv2.o \
   slapll.o slapmt.o \
   slaqgb.o slaqge.o slaqp2.o slaqps.o slaqsb.o slaqsp.o slaqsy.o \
   slaqr0.o slaqr1.o slaqr2.o slaqr3.o slaqr4.o slaqr5.o \
   slaqtr.o slar1v.o slar2v.o ilaslr.o ilaslc.o \
   slarf.o  slarfb.o slarfg.o slarfgp.o slarft.o slarfx.o slarfy.o slargv.o \
   slarrv.o slartv.o \
   slarz.o  slarzb.o slarzt.o slaswp.o slasy2.o slasyf.o slasyf_rook.o \
   slasyf_rk.o \
   slatbs.o slatdf.o slatps.o slatrd.o slatrs.o slatrz.o \
   slauu2.o slauum.o sopgtr.o sopmtr.o sorg2l.o sorg2r.o \
   sorgbr.o sorghr.o sorgl2.o sorglq.o sorgql.o sorgqr.o sorgr2.o \
   sorgrq.o sorgtr.o sorm2l.o sorm2r.o sorm22.o \
   sormbr.o sormhr.o sorml2.o sormlq.o sormql.o sormqr.o sormr2.o \
   sormr3.o sormrq.o sormrz.o sormtr.o spbcon.o spbequ.o spbrfs.o \
   spbstf.o spbsv.o  spbsvx.o \
   spbtf2.o spbtrf.o spbtrs.o spocon.o spoequ.o sporfs.o sposv.o \
   sposvx.o spotf2.o spotri.o spstrf.o spstf2.o \
   sppcon.o sppequ.o \
   spprfs.o sppsv.o  sppsvx.o spptrf.o spptri.o spptrs.o sptcon.o \
   spteqr.o sptrfs.o sptsv.o  sptsvx.o spttrs.o sptts2.o srscl.o \
   ssbev.o  ssbevd.o ssbevx.o ssbgst.o ssbgv.o  ssbgvd.o ssbgvx.o \
   ssbtrd.o sspcon.o sspev.o  sspevd.o sspevx.o sspgst.o \
   sspgv.o  sspgvd.o sspgvx.o ssprfs.o sspsv.o  sspsvx.o ssptrd.o \
   ssptrf.o ssptri.o ssptrs.o sstegr.o sstein.o sstev.o  sstevd.o sstevr.o \
   sstevx.o \
   ssycon.o ssyev.o  ssyevd.o ssyevr.o ssyevx.o ssygs2.o \
   ssygst.o ssygv.o  ssygvd.o ssygvx.o ssyrfs.o ssysv.o  ssysvx.o \
   ssytd2.o ssytf2.o ssytrd.o ssytrf.o ssytri.o ssytri2.o ssytri2x.o \
   ssyswapr.o ssytrs.o ssytrs2.o \
   ssyconv.o ssyconvf.o ssyconvf_rook.o \
   ssytf2_rook.o ssytrf_rook.o ssytrs_rook.o \
   ssytri_rook.o ssycon_rook.o ssysv_rook.o \
   ssytf2_rk.o ssytrf_rk.o ssytrs_3.o \
   ssytri_3.o ssytri_3x.o ssycon_3.o ssysv_rk.o \
   slasyf_aa.o ssysv_aa.o ssytrf_aa.o ssytrs_aa.o \
   stbcon.o \
   stbrfs.o stbtrs.o stgevc.o stgex2.o stgexc.o stgsen.o \
   stgsja.o stgsna.o stgsy2.o stgsyl.o stpcon.o stprfs.o stptri.o \
   stptrs.o \
   strcon.o strevc.o strevc3.o strexc.o strrfs.o strsen.o strsna.o strsyl.o \
   strti2.o strtri.o strtrs.o stzrzf.o sstemr.o \
   slansf.o spftrf.o spftri.o spftrs.o ssfrk.o stfsm.o stftri.o stfttp.o \
   stfttr.o stpttf.o stpttr.o strttf.o strttp.o \
   sgejsv.o sgesvj.o sgsvj0.o sgsvj1.o \
   sgeequb.o ssyequb.o spoequb.o sgbequb.o \
   sbbcsd.o slapmr.o sorbdb.o sorbdb1.o sorbdb2.o sorbdb3.o sorbdb4.o \
   sorbdb5.o sorbdb6.o sorcsd.o sorcsd2by1.o \
   sgeqrt.o sgeqrt2.o sgeqrt3.o sgemqrt.o \
   stpqrt.o stpqrt2.o stpmqrt.o stprfb.o \
   sgelqt.o sgelqt3.o sgemlqt.o \
   sgetsls.o sgeqr.o slatsqr.o slamtsqr.o sgemqr.o \
   sgelq.o slaswlq.o slamswlq.o sgemlq.o \
   stplqt.o stplqt2.o stpmlqt.o \
   ssytrd_2stage.o ssytrd_sy2sb.o ssytrd_sb2st.o ssb2st_kernels.o \
   ssyevd_2stage.o ssyev_2stage.o ssyevx_2stage.o ssyevr_2stage.o \
   ssbev_2stage.o ssbevx_2stage.o ssbevd_2stage.o ssygv_2stage.o

DSLASRC = spotrs.o sgetrs.o spotrf.o sgetrf.o

ifdef USEXBLAS
SXLASRC = sgesvxx.o sgerfsx.o sla_gerfsx_extended.o sla_geamv.o \
   sla_gercond.o sla_gerpvgrw.o ssysvxx.o ssyrfsx.o \
   sla_syrfsx_extended.o sla_syamv.o sla_syrcond.o sla_syrpvgrw.o \
   sposvxx.o sporfsx.o sla_porfsx_extended.o sla_porcond.o \
   sla_porpvgrw.o sgbsvxx.o sgbrfsx.o sla_gbrfsx_extended.o \
   sla_gbamv.o sla_gbrcond.o sla_gbrpvgrw.o sla_lin_berr.o slarscl2.o \
   slascl2.o sla_wwaddw.o
endif

CLASRC = \
   cpotrf2.o cgetrf2.o \
   cbdsqr.o cgbbrd.o cgbcon.o cgbequ.o cgbrfs.o cgbsv.o  cgbsvx.o \
   cgbtf2.o cgbtrf.o cgbtrs.o cgebak.o cgebal.o cgebd2.o cgebrd.o \
   cgecon.o cgeequ.o cgees.o  cgeesx.o cgeev.o  cgeevx.o \
   cgehd2.o cgehrd.o cgelq2.o cgelqf.o \
   cgels.o  cgelsd.o cgelss.o cgelsy.o cgeql2.o cgeqlf.o cgeqp3.o \
   cgeqr2.o cgeqr2p.o cgeqrf.o cgeqrfp.o cgerfs.o \
   cgerq2.o cgerqf.o cgesc2.o cgesdd.o cgesv.o  cgesvd.o  cgesvdx.o \
   cgesvj.o cgejsv.o cgsvj0.o cgsvj1.o \
   cgesvx.o cgetc2.o cgetf2.o cgetri.o \
   cggbak.o cggbal.o cgges.o  cgges3.o cggesx.o \
   cggev.o  cggev3.o cggevx.o cggglm.o \
   cgghrd.o cgghd3.o cgglse.o cggqrf.o cggrqf.o \
   cggsvd3.o cggsvp3.o \
   cgtcon.o cgtrfs.o cgtsv.o  cgtsvx.o cgttrf.o cgttrs.o cgtts2.o chbev.o \
   chbevd.o chbevx.o chbgst.o chbgv.o  chbgvd.o chbgvx.o chbtrd.o \
   checon.o cheev.o  cheevd.o cheevr.o cheevx.o chegs2.o chegst.o \
   chegv.o  chegvd.o chegvx.o cherfs.o chesv.o  chesvx.o chetd2.o \
   chetf2.o chetrd.o \
   chetrf.o chetri.o chetri2.o chetri2x.o cheswapr.o \
   chetrs.o chetrs2.o \
   chetf2_rook.o chetrf_rook.o chetri_rook.o \
   chetrs_rook.o checon_rook.o chesv_rook.o \
   chetf2_rk.o chetrf_rk.o chetri_3.o chetri_3x.o \
   chetrs_3.o checon_3.o chesv_rk.o \
   chesv_aa.o chetrf_aa.o chetrs_aa.o clahef_aa.o \
   chgeqz.o chpcon.o chpev.o  chpevd.o \
   chpevx.o chpgst.o chpgv.o  chpgvd.o chpgvx.o chprfs.o chpsv.o \
   chpsvx.o \
   chptrd.o chptrf.o chptri.o chptrs.o chsein.o chseqr.o clabrd.o \
   clacgv.o clacon.o clacn2.o clacp2.o clacpy.o clacrm.o clacrt.o cladiv.o \
   claed0.o claed7.o claed8.o \
   claein.o claesy.o claev2.o clags2.o clagtm.o \
   clahef.o clahef_rook.o clahef_rk.o clahqr.o \
   clahr2.o claic1.o clals0.o clalsa.o clalsd.o clangb.o clange.o clangt.o \
   clanhb.o clanhe.o \
   clanhp.o clanhs.o clanht.o clansb.o clansp.o clansy.o clantb.o \
   clantp.o clantr.o clapll.o clapmt.o clarcm.o claqgb.o claqge.o \
   claqhb.o claqhe.o claqhp.o claqp2.o claqps.o claqsb.o \
   claqr0.o claqr1.o claqr2.o claqr3.o claqr4.o claqr5.o \
   claqsp.o claqsy.o clar1v.o clar2v.o ilaclr.o ilaclc.o \
   clarf.o  clarfb.o clarfg.o clarft.o clarfgp.o \
   clarfx.o clarfy.o clargv.o clarnv.o clarrv.o clartg.o clartv.o \
   clarz.o  clarzb.o clarzt.o clascl.o claset.o clasr.o  classq.o \
   claswp.o clasyf.o clasyf_rook.o clasyf_rk.o clasyf_aa.o \
   clatbs.o clatdf.o clatps.o clatrd.o clatrs.o clatrz.o \
   clauu2.o clauum.o cpbcon.o cpbequ.o cpbrfs.o cpbstf.o cpbsv.o \
   cpbsvx.o cpbtf2.o cpbtrf.o cpbtrs.o cpocon.o cpoequ.o cporfs.o \
   cposv.o  cposvx.o cpotf2.o cpotri.o cpstrf.o cpstf2.o \
   cppcon.o cppequ.o cpprfs.o cppsv.o  cppsvx.o cpptrf.o cpptri.o cpptrs.o \
   cptcon.o cpteqr.o cptrfs.o cptsv.o  cptsvx.o cpttrf.o cpttrs.o cptts2.o \
   crot.o   cspcon.o cspmv.o  cspr.o   csprfs.o cspsv.o \
   cspsvx.o csptrf.o csptri.o csptrs.o csrscl.o cstedc.o \
   cstegr.o cstein.o csteqr.o \
   csycon.o csymv.o \
   csyr.o csyrfs.o csysv.o csysvx.o csytf2.o csytrf.o csytri.o csytri2.o csytri2x.o \
   csyswapr.o csytrs.o csytrs2.o \
   csyconv.o csyconvf.o csyconvf_rook.o \
   csytf2_rook.o csytrf_rook.o csytrs_rook.o \
   csytri_rook.o csycon_rook.o csysv_rook.o \

=== CBLAS/src/CMakeLists.txt ===
# This Makefile compiles the CBLAS routines

# Error handling routines for level 2 & 3
set(ERRHAND cblas_globals.c cblas_xerbla.c xerbla.c)

#
#
# CBLAS routines
#
# Level 1
#
#

# Files for level 1 single precision real
set(SLEV1 cblas_srotg.c cblas_srotmg.c cblas_srot.c cblas_srotm.c
         cblas_sswap.c cblas_sscal.c  cblas_scopy.c cblas_saxpy.c
         cblas_sdot.c  cblas_sdsdot.c cblas_snrm2.c cblas_sasum.c
         cblas_isamax.c sdotsub.f sdsdotsub.f snrm2sub.f sasumsub.f
         isamaxsub.f)

# Files for level 1 double precision real
set(DLEV1 cblas_drotg.c cblas_drotmg.c cblas_drot.c cblas_drotm.c
         cblas_dswap.c cblas_dscal.c  cblas_dcopy.c cblas_daxpy.c
         cblas_ddot.c  cblas_dsdot.c cblas_dnrm2.c cblas_dasum.c
         cblas_idamax.c ddotsub.f dsdotsub.f dnrm2sub.f
         dasumsub.f idamaxsub.f)

# Files for level 1 single precision complex
set(CLEV1 cblas_cswap.c cblas_cscal.c cblas_csscal.c cblas_ccopy.c
         cblas_caxpy.c cblas_cdotu_sub.c cblas_cdotc_sub.c
         cblas_icamax.c cdotcsub.f cdotusub.f icamaxsub.f)

# Files for level 1 double precision complex
set(ZLEV1 cblas_zswap.c cblas_zscal.c cblas_zdscal.c cblas_zcopy.c
         cblas_zaxpy.c cblas_zdotu_sub.c cblas_zdotc_sub.c cblas_dznrm2.c
         cblas_dzasum.c cblas_izamax.c zdotcsub.f zdotusub.f
         dzasumsub.f dznrm2sub.f izamaxsub.f)

# Common files for level 1 single precision
set(SCLEV1 cblas_scasum.c scasumsub.f cblas_scnrm2.c scnrm2sub.f)

#
#
# CBLAS routines
#
# Level 2
#
#

# Files for level 2 single precision real
set(SLEV2 cblas_sgemv.c cblas_sgbmv.c cblas_sger.c  cblas_ssbmv.c cblas_sspmv.c
        cblas_sspr.c  cblas_sspr2.c cblas_ssymv.c cblas_ssyr.c  cblas_ssyr2.c
        cblas_stbmv.c cblas_stbsv.c cblas_stpmv.c cblas_stpsv.c cblas_strmv.c
        cblas_strsv.c)

# Files for level 2 double precision real
set(DLEV2 cblas_dgemv.c cblas_dgbmv.c cblas_dger.c  cblas_dsbmv.c cblas_dspmv.c
        cblas_dspr.c  cblas_dspr2.c cblas_dsymv.c cblas_dsyr.c  cblas_dsyr2.c
        cblas_dtbmv.c cblas_dtbsv.c cblas_dtpmv.c cblas_dtpsv.c cblas_dtrmv.c
        cblas_dtrsv.c)

# Files for level 2 single precision complex
set(CLEV2 cblas_cgemv.c cblas_cgbmv.c cblas_chemv.c cblas_chbmv.c cblas_chpmv.c
        cblas_ctrmv.c cblas_ctbmv.c cblas_ctpmv.c cblas_ctrsv.c cblas_ctbsv.c
        cblas_ctpsv.c cblas_cgeru.c cblas_cgerc.c cblas_cher.c  cblas_cher2.c
        cblas_chpr.c  cblas_chpr2.c)

# Files for level 2 double precision complex
set(ZLEV2 cblas_zgemv.c cblas_zgbmv.c cblas_zhemv.c cblas_zhbmv.c cblas_zhpmv.c
        cblas_ztrmv.c cblas_ztbmv.c cblas_ztpmv.c cblas_ztrsv.c cblas_ztbsv.c
        cblas_ztpsv.c cblas_zgeru.c cblas_zgerc.c cblas_zher.c  cblas_zher2.c
        cblas_zhpr.c  cblas_zhpr2.c)

#
#
# CBLAS routines
#
# Level 3
#
#

# Files for level 3 single precision real
set(SLEV3 cblas_sgemm.c cblas_ssymm.c cblas_ssyrk.c cblas_ssyr2k.c cblas_strmm.c
        cblas_strsm.c)

# Files for level 3 double precision real
set(DLEV3 cblas_dgemm.c cblas_dsymm.c cblas_dsyrk.c cblas_dsyr2k.c cblas_dtrmm.c
        cblas_dtrsm.c)

# Files for level 3 single precision complex
set(CLEV3 cblas_cgemm.c cblas_csymm.c cblas_chemm.c cblas_cherk.c
        cblas_cher2k.c cblas_ctrmm.c cblas_ctrsm.c cblas_csyrk.c
        cblas_csyr2k.c)

# Files for level 3 double precision complex
set(ZLEV3 cblas_zgemm.c cblas_zsymm.c cblas_zhemm.c cblas_zherk.c
        cblas_zher2k.c cblas_ztrmm.c cblas_ztrsm.c cblas_zsyrk.c
        cblas_zsyr2k.c)


set(SOURCES)
if(BUILD_SINGLE)
  list(APPEND SOURCES ${SLEV1} ${SCLEV1} ${SLEV2} ${SLEV3} ${ERRHAND})
endif()
if(BUILD_DOUBLE)
  list(APPEND SOURCES ${DLEV1} ${DLEV2} ${DLEV3} ${ERRHAND})
endif()
if(BUILD_COMPLEX)
  list(APPEND SOURCES ${CLEV1} ${SCLEV1} ${CLEV2} ${CLEV3} ${ERRHAND})
endif()
if(BUILD_COMPLEX16)
  list(APPEND SOURCES ${ZLEV1} ${ZLEV2} ${ZLEV3} ${ERRHAND})
endif()
list(REMOVE_DUPLICATES SOURCES)

add_library(cblas ${SOURCES})
set_target_properties(
  cblas PROPERTIES
  LINKER_LANGUAGE C
  VERSION ${LAPACK_VERSION}
  SOVERSION ${LAPACK_MAJOR_VERSION}
  )
target_link_libraries(cblas PRIVATE ${BLAS_LIBRARIES})
lapack_install_library(cblas)

=== LAPACKE/src/CMakeLists.txt ===
set(SOURCES
lapacke_cbbcsd.c
lapacke_cbbcsd_work.c
lapacke_cbdsqr.c
lapacke_cbdsqr_work.c
lapacke_cgbbrd.c
lapacke_cgbbrd_work.c
lapacke_cgbcon.c
lapacke_cgbcon_work.c
lapacke_cgbequ.c
lapacke_cgbequ_work.c
lapacke_cgbequb.c
lapacke_cgbequb_work.c
lapacke_cgbrfs.c
lapacke_cgbrfs_work.c
lapacke_cgbsv.c
lapacke_cgbsv_work.c
lapacke_cgbsvx.c
lapacke_cgbsvx_work.c
lapacke_cgbtrf.c
lapacke_cgbtrf_work.c
lapacke_cgbtrs.c
lapacke_cgbtrs_work.c
lapacke_cgebak.c
lapacke_cgebak_work.c
lapacke_cgebal.c
lapacke_cgebal_work.c
lapacke_cgebrd.c
lapacke_cgebrd_work.c
lapacke_cgecon.c
lapacke_cgecon_work.c
lapacke_cgeequ.c
lapacke_cgeequ_work.c
lapacke_cgeequb.c
lapacke_cgeequb_work.c
lapacke_cgees.c
lapacke_cgees_work.c
lapacke_cgeesx.c
lapacke_cgeesx_work.c
lapacke_cgeev.c
lapacke_cgeev_work.c
lapacke_cgeevx.c
lapacke_cgeevx_work.c
lapacke_cgehrd.c
lapacke_cgehrd_work.c
lapacke_cgejsv.c
lapacke_cgejsv_work.c
lapacke_cgelq.c
lapacke_cgelq_work.c
lapacke_cgelq2.c
lapacke_cgelq2_work.c
lapacke_cgelqf.c
lapacke_cgelqf_work.c
lapacke_cgels.c
lapacke_cgels_work.c
lapacke_cgelsd.c
lapacke_cgelsd_work.c
lapacke_cgelss.c
lapacke_cgelss_work.c
lapacke_cgelsy.c
lapacke_cgelsy_work.c
lapacke_cgemlq.c
lapacke_cgemlq_work.c
lapacke_cgemqr.c
lapacke_cgemqr_work.c
lapacke_cgemqrt.c
lapacke_cgemqrt_work.c
lapacke_cgeqlf.c
lapacke_cgeqlf_work.c
lapacke_cgeqp3.c
lapacke_cgeqp3_work.c
lapacke_cgeqr.c
lapacke_cgeqr_work.c
lapacke_cgeqr2.c
lapacke_cgeqr2_work.c
lapacke_cgeqrf.c
lapacke_cgeqrf_work.c
lapacke_cgeqrfp.c
lapacke_cgeqrfp_work.c
lapacke_cgeqrt.c
lapacke_cgeqrt2.c
lapacke_cgeqrt2_work.c
lapacke_cgeqrt3.c
lapacke_cgeqrt3_work.c
lapacke_cgeqrt_work.c
lapacke_cgerfs.c
lapacke_cgerfs_work.c
lapacke_cgerqf.c
lapacke_cgerqf_work.c
lapacke_cgesdd.c
lapacke_cgesdd_work.c
lapacke_cgesv.c
lapacke_cgesv_work.c
lapacke_cgesvd.c
lapacke_cgesvd_work.c
lapacke_cgesvdx.c
lapacke_cgesvdx_work.c
lapacke_cgesvj.c
lapacke_cgesvj_work.c
lapacke_cgesvx.c
lapacke_cgesvx_work.c
lapacke_cgetf2.c
lapacke_cgetf2_work.c
lapacke_cgetrf.c
lapacke_cgetrf_work.c
lapacke_cgetrf2.c
lapacke_cgetrf2_work.c
lapacke_cgetri.c
lapacke_cgetri_work.c
lapacke_cgetrs.c
lapacke_cgetrs_work.c
lapacke_cgetsls.c
lapacke_cgetsls_work.c
lapacke_cggbak.c
lapacke_cggbak_work.c
lapacke_cggbal.c
lapacke_cggbal_work.c
lapacke_cgges.c
lapacke_cgges_work.c
lapacke_cgges3.c
lapacke_cgges3_work.c
lapacke_cggesx.c
lapacke_cggesx_work.c
lapacke_cggev.c
lapacke_cggev_work.c
lapacke_cggev3.c
lapacke_cggev3_work.c
lapacke_cggevx.c
lapacke_cggevx_work.c
lapacke_cggglm.c
lapacke_cggglm_work.c
lapacke_cgghrd.c
lapacke_cgghrd_work.c
lapacke_cgghd3.c
lapacke_cgghd3_work.c
lapacke_cgglse.c
lapacke_cgglse_work.c
lapacke_cggqrf.c
lapacke_cggqrf_work.c
lapacke_cggrqf.c
lapacke_cggrqf_work.c
lapacke_cggsvd3.c
lapacke_cggsvd3_work.c
lapacke_cggsvp3.c
lapacke_cggsvp3_work.c
lapacke_cgtcon.c
lapacke_cgtcon_work.c
lapacke_cgtrfs.c
lapacke_cgtrfs_work.c
lapacke_cgtsv.c
lapacke_cgtsv_work.c
lapacke_cgtsvx.c
lapacke_cgtsvx_work.c
lapacke_cgttrf.c
lapacke_cgttrf_work.c
lapacke_cgttrs.c
lapacke_cgttrs_work.c
lapacke_chbev.c
lapacke_chbev_work.c
lapacke_chbevd.c
lapacke_chbevd_work.c
lapacke_chbevx.c
lapacke_chbevx_work.c
lapacke_chbev_2stage.c
lapacke_chbev_2stage_work.c
lapacke_chbevd_2stage.c
lapacke_chbevd_2stage_work.c
lapacke_chbevx_2stage.c
lapacke_chbevx_2stage_work.c
lapacke_chbgst.c
lapacke_chbgst_work.c
lapacke_chbgv.c
lapacke_chbgv_work.c
lapacke_chbgvd.c
lapacke_chbgvd_work.c
lapacke_chbgvx.c
lapacke_chbgvx_work.c
lapacke_chbtrd.c
lapacke_chbtrd_work.c
lapacke_checon.c
lapacke_checon_work.c
lapacke_checon_3.c
lapacke_checon_3_work.c
lapacke_cheequb.c
lapacke_cheequb_work.c
lapacke_cheev.c
lapacke_cheev_work.c
lapacke_cheevd.c
lapacke_cheevd_work.c
lapacke_cheevr.c
lapacke_cheevr_work.c
lapacke_cheevx.c
lapacke_cheevx_work.c
lapacke_cheev_2stage.c
lapacke_cheev_2stage_work.c
lapacke_cheevd_2stage.c
lapacke_cheevd_2stage_work.c
lapacke_cheevr_2stage.c
lapacke_cheevr_2stage_work.c
lapacke_cheevx_2stage.c
lapacke_cheevx_2stage_work.c
lapacke_chegst.c
lapacke_chegst_work.c
lapacke_chegv.c
lapacke_chegv_work.c
lapacke_chegv_2stage.c
lapacke_chegv_2stage_work.c
lapacke_chegvd.c
lapacke_chegvd_work.c
lapacke_chegvx.c
lapacke_chegvx_work.c
lapacke_cherfs.c
lapacke_cherfs_work.c
lapacke_chesv.c
lapacke_chesv_work.c
lapacke_chesv_aa.c
lapacke_chesv_aa_work.c
lapacke_chesv_rk.c
lapacke_chesv_rk_work.c
lapacke_chesvx.c
lapacke_chesvx_work.c
lapacke_cheswapr.c
lapacke_cheswapr_work.c
lapacke_chetrd.c
lapacke_chetrd_work.c
lapacke_chetrf.c
lapacke_chetrf_rook.c
lapacke_chetrf_work.c
lapacke_chetrf_rook_work.c
lapacke_chetrf_aa.c
lapacke_chetrf_aa_work.c
lapacke_chetrf_rk.c
lapacke_chetrf_rk_work.c
lapacke_chetri.c
lapacke_chetri2.c
lapacke_chetri2_work.c
lapacke_chetri_3.c
lapacke_chetri_3_work.c
lapacke_chetri2x.c
lapacke_chetri2x_work.c
lapacke_chetri_work.c
lapacke_chetrs.c
lapacke_chetrs_rook.c
lapacke_chetrs2.c
lapacke_chetrs2_work.c
lapacke_chetrs_work.c
lapacke_chetrs_rook_work.c
lapacke_chetrs_aa.c
lapacke_chetrs_aa_work.c
lapacke_chetrs_3.c
lapacke_chetrs_3_work.c
lapacke_chfrk.c
lapacke_chfrk_work.c
lapacke_chgeqz.c
lapacke_chgeqz_work.c
lapacke_chpcon.c
lapacke_chpcon_work.c
lapacke_chpev.c
lapacke_chpev_work.c
lapacke_chpevd.c
lapacke_chpevd_work.c
lapacke_chpevx.c
lapacke_chpevx_work.c
lapacke_chpgst.c
lapacke_chpgst_work.c
lapacke_chpgv.c
lapacke_chpgv_work.c
lapacke_chpgvd.c
lapacke_chpgvd_work.c
lapacke_chpgvx.c
lapacke_chpgvx_work.c
lapacke_chprfs.c
lapacke_chprfs_work.c
lapacke_chpsv.c
lapacke_chpsv_work.c
lapacke_chpsvx.c
lapacke_chpsvx_work.c
lapacke_chptrd.c
lapacke_chptrd_work.c
lapacke_chptrf.c
lapacke_chptrf_work.c
lapacke_chptri.c
lapacke_chptri_work.c
lapacke_chptrs.c
lapacke_chptrs_work.c
lapacke_chsein.c
lapacke_chsein_work.c
lapacke_chseqr.c
lapacke_chseqr_work.c
lapacke_clacgv.c
lapacke_clacgv_work.c
lapacke_clacn2.c
lapacke_clacn2_work.c
lapacke_clacp2.c
lapacke_clacp2_work.c
lapacke_clacpy.c
lapacke_clacpy_work.c
lapacke_clag2z.c
lapacke_clag2z_work.c
lapacke_clange.c
lapacke_clange_work.c
lapacke_clanhe.c
lapacke_clanhe_work.c
lapacke_clansy.c
lapacke_clansy_work.c
lapacke_clantr.c
lapacke_clantr_work.c
lapacke_clapmr.c
lapacke_clapmr_work.c
lapacke_clapmt.c
lapacke_clapmt_work.c
lapacke_clarfb.c
lapacke_clarfb_work.c
lapacke_clarfg.c
lapacke_clarfg_work.c
lapacke_clarft.c
lapacke_clarft_work.c
lapacke_clarfx.c
lapacke_clarfx_work.c
lapacke_clarnv.c
lapacke_clarnv_work.c
lapacke_clascl.c
lapacke_clascl_work.c
lapacke_claset.c
lapacke_claset_work.c
lapacke_classq.c
lapacke_classq_work.c
lapacke_claswp.c
lapacke_claswp_work.c
lapacke_clauum.c
lapacke_clauum_work.c
lapacke_cpbcon.c
lapacke_cpbcon_work.c
lapacke_cpbequ.c
lapacke_cpbequ_work.c
lapacke_cpbrfs.c
lapacke_cpbrfs_work.c
lapacke_cpbstf.c
lapacke_cpbstf_work.c
lapacke_cpbsv.c
lapacke_cpbsv_work.c
lapacke_cpbsvx.c
lapacke_cpbsvx_work.c
lapacke_cpbtrf.c
lapacke_cpbtrf_work.c
lapacke_cpbtrs.c
lapacke_cpbtrs_work.c
lapacke_cpftrf.c
lapacke_cpftrf_work.c
lapacke_cpftri.c
lapacke_cpftri_work.c
lapacke_cpftrs.c
lapacke_cpftrs_work.c
lapacke_cpocon.c
lapacke_cpocon_work.c
lapacke_cpoequ.c
lapacke_cpoequ_work.c
lapacke_cpoequb.c
lapacke_cpoequb_work.c
lapacke_cporfs.c
lapacke_cporfs_work.c
lapacke_cposv.c
lapacke_cposv_work.c
lapacke_cposvx.c
lapacke_cposvx_work.c
lapacke_cpotrf.c
lapacke_cpotrf_work.c
lapacke_cpotrf2.c
lapacke_cpotrf2_work.c
lapacke_cpotri.c
lapacke_cpotri_work.c
lapacke_cpotrs.c
lapacke_cpotrs_work.c
lapacke_cppcon.c
lapacke_cppcon_work.c
lapacke_cppequ.c
lapacke_cppequ_work.c
lapacke_cpprfs.c
lapacke_cpprfs_work.c
lapacke_cppsv.c
lapacke_cppsv_work.c
lapacke_cppsvx.c
lapacke_cppsvx_work.c
lapacke_cpptrf.c
lapacke_cpptrf_work.c
lapacke_cpptri.c
lapacke_cpptri_work.c
lapacke_cpptrs.c
lapacke_cpptrs_work.c
lapacke_cpstrf.c
lapacke_cpstrf_work.c
lapacke_cptcon.c
lapacke_cptcon_work.c
lapacke_cpteqr.c
lapacke_cpteqr_work.c
lapacke_cptrfs.c
lapacke_cptrfs_work.c
lapacke_cptsv.c
lapacke_cptsv_work.c
lapacke_cptsvx.c
lapacke_cptsvx_work.c
lapacke_cpttrf.c
lapacke_cpttrf_work.c
lapacke_cpttrs.c
lapacke_cpttrs_work.c
lapacke_cspcon.c
lapacke_cspcon_work.c
lapacke_csprfs.c
lapacke_csprfs_work.c
lapacke_cspsv.c
lapacke_cspsv_work.c
lapacke_cspsvx.c
lapacke_cspsvx_work.c
lapacke_csptrf.c
lapacke_csptrf_work.c
lapacke_csptri.c
lapacke_csptri_work.c
lapacke_csptrs.c
lapacke_csptrs_work.c
lapacke_cstedc.c
lapacke_cstedc_work.c
lapacke_cstegr.c
lapacke_cstegr_work.c
lapacke_cstein.c
lapacke_cstein_work.c
lapacke_cstemr.c
lapacke_cstemr_work.c
lapacke_csteqr.c
lapacke_csteqr_work.c
lapacke_csycon.c
lapacke_csycon_work.c
lapacke_csycon_3.c
lapacke_csycon_3_work.c
lapacke_csyconv.c
lapacke_csyconv_work.c
lapacke_csyequb.c
lapacke_csyequb_work.c
lapacke_csyrfs.c
lapacke_csyrfs_work.c
lapacke_csysv.c
lapacke_csysv_rook.c
lapacke_csysv_rook_work.c
lapacke_csysv_work.c
lapacke_csysv_aa.c
lapacke_csysv_aa_work.c
lapacke_csysv_rk.c
lapacke_csysv_rk_work.c
lapacke_csysvx.c
lapacke_csysvx_work.c
lapacke_csyswapr.c
lapacke_csyswapr_work.c
lapacke_csytrf.c
lapacke_csytrf_work.c
lapacke_csytrf_rook.c
lapacke_csytrf_rook_work.c
lapacke_csytrf_aa.c
lapacke_csytrf_aa_work.c
lapacke_csytrf_rk.c
lapacke_csytrf_rk_work.c
lapacke_csytri.c
lapacke_csytri2.c
lapacke_csytri2_work.c
lapacke_csytri_3.c
lapacke_csytri_3_work.c
lapacke_csytri2x.c
lapacke_csytri2x_work.c
lapacke_csytri_work.c
lapacke_csytrs.c
lapacke_csytrs_rook.c
lapacke_csytrs2.c
lapacke_csytrs2_work.c
lapacke_csytrs_work.c
lapacke_csytrs_rook_work.c
lapacke_csytrs_aa.c
lapacke_csytrs_aa_work.c
lapacke_csytrs_3.c
lapacke_csytrs_3_work.c
lapacke_ctbcon.c
lapacke_ctbcon_work.c
lapacke_ctbrfs.c
lapacke_ctbrfs_work.c
lapacke_ctbtrs.c
lapacke_ctbtrs_work.c
lapacke_ctfsm.c
lapacke_ctfsm_work.c
lapacke_ctftri.c
lapacke_ctftri_work.c
lapacke_ctfttp.c
lapacke_ctfttp_work.c
lapacke_ctfttr.c
lapacke_ctfttr_work.c
lapacke_ctgevc.c
lapacke_ctgevc_work.c
lapacke_ctgexc.c
lapacke_ctgexc_work.c
lapacke_ctgsen.c
lapacke_ctgsen_work.c
lapacke_ctgsja.c
lapacke_ctgsja_work.c
lapacke_ctgsna.c
lapacke_ctgsna_work.c
lapacke_ctgsyl.c
lapacke_ctgsyl_work.c
lapacke_ctpcon.c
lapacke_ctpcon_work.c
lapacke_ctpmqrt.c
lapacke_ctpmqrt_work.c
lapacke_ctpqrt.c
lapacke_ctpqrt2.c
lapacke_ctpqrt2_work.c
lapacke_ctpqrt_work.c
lapacke_ctprfb.c
lapacke_ctprfb_work.c
lapacke_ctprfs.c
lapacke_ctprfs_work.c
lapacke_ctptri.c
lapacke_ctptri_work.c
lapacke_ctptrs.c
lapacke_ctptrs_work.c
lapacke_ctpttf.c
lapacke_ctpttf_work.c
lapacke_ctpttr.c
lapacke_ctpttr_work.c
lapacke_ctrcon.c
lapacke_ctrcon_work.c
lapacke_ctrevc.c
lapacke_ctrevc_work.c
lapacke_ctrexc.c
lapacke_ctrexc_work.c
lapacke_ctrrfs.c
lapacke_ctrrfs_work.c
lapacke_ctrsen.c
lapacke_ctrsen_work.c
lapacke_ctrsna.c
lapacke_ctrsna_work.c
lapacke_ctrsyl.c
lapacke_ctrsyl_work.c
lapacke_ctrtri.c
lapacke_ctrtri_work.c
lapacke_ctrtrs.c
lapacke_ctrtrs_work.c
lapacke_ctrttf.c
lapacke_ctrttf_work.c
lapacke_ctrttp.c
lapacke_ctrttp_work.c
lapacke_ctzrzf.c
lapacke_ctzrzf_work.c
lapacke_cunbdb.c
lapacke_cunbdb_work.c
lapacke_cuncsd.c
lapacke_cuncsd_work.c
lapacke_cuncsd2by1.c
lapacke_cuncsd2by1_work.c
lapacke_cungbr.c
lapacke_cungbr_work.c
lapacke_cunghr.c
lapacke_cunghr_work.c
lapacke_cunglq.c
lapacke_cunglq_work.c
lapacke_cungql.c
lapacke_cungql_work.c
lapacke_cungqr.c
lapacke_cungqr_work.c
lapacke_cungrq.c
lapacke_cungrq_work.c
lapacke_cungtr.c
lapacke_cungtr_work.c
lapacke_cunmbr.c
lapacke_cunmbr_work.c
lapacke_cunmhr.c
lapacke_cunmhr_work.c
lapacke_cunmlq.c
lapacke_cunmlq_work.c
lapacke_cunmql.c
lapacke_cunmql_work.c
lapacke_cunmqr.c
lapacke_cunmqr_work.c
lapacke_cunmrq.c
lapacke_cunmrq_work.c
lapacke_cunmrz.c
lapacke_cunmrz_work.c
lapacke_cunmtr.c
lapacke_cunmtr_work.c
lapacke_cupgtr.c
lapacke_cupgtr_work.c
lapacke_cupmtr.c
lapacke_cupmtr_work.c
lapacke_dbbcsd.c
lapacke_dbbcsd_work.c
lapacke_dbdsdc.c
lapacke_dbdsdc_work.c
lapacke_dbdsvdx.c
lapacke_dbdsvdx_work.c
lapacke_dbdsqr.c
lapacke_dbdsqr_work.c
lapacke_ddisna.c
lapacke_ddisna_work.c
lapacke_dgbbrd.c
lapacke_dgbbrd_work.c
lapacke_dgbcon.c
lapacke_dgbcon_work.c
lapacke_dgbequ.c
lapacke_dgbequ_work.c

=== LAPACKE/utils/Makefile ===
##############################################################################
# Copyright (c) 2010, Intel Corp.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#   * Redistributions of source code must retain the above copyright notice,
#     this list of conditions and the following disclaimer.
#   * Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   * Neither the name of Intel Corporation nor the names of its contributors
#     may be used to endorse or promote products derived from this software
#     without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.
##############################################################################
# Contents: Native C interface to LAPACK
# Author: Intel Corporation
# September, 2010
##############################################################################
# makefile for LAPACKE, used to build lapacke binary.
#
include ../../make.inc

OBJ = lapacke_cgb_nancheck.o \
      lapacke_cgb_trans.o \
      lapacke_cge_nancheck.o \
      lapacke_cge_trans.o \
      lapacke_cgg_nancheck.o \
      lapacke_cgg_trans.o \
      lapacke_cgt_nancheck.o \
      lapacke_chb_nancheck.o \
      lapacke_chb_trans.o \
      lapacke_che_nancheck.o \
      lapacke_che_trans.o \
      lapacke_chp_nancheck.o \
      lapacke_chp_trans.o \
      lapacke_chs_nancheck.o \
      lapacke_chs_trans.o \
      lapacke_c_nancheck.o \
      lapacke_cpb_nancheck.o \
      lapacke_cpb_trans.o \
      lapacke_cpf_nancheck.o \
      lapacke_cpf_trans.o \
      lapacke_cpo_nancheck.o \
      lapacke_cpo_trans.o \
      lapacke_cpp_nancheck.o \
      lapacke_cpp_trans.o \
      lapacke_cpt_nancheck.o \
      lapacke_csp_nancheck.o \
      lapacke_csp_trans.o \
      lapacke_cst_nancheck.o \
      lapacke_csy_nancheck.o \
      lapacke_csy_trans.o \
      lapacke_ctb_nancheck.o \
      lapacke_ctb_trans.o \
      lapacke_ctf_nancheck.o \
      lapacke_ctf_trans.o \
      lapacke_ctp_nancheck.o \
      lapacke_ctp_trans.o \
      lapacke_ctr_nancheck.o \
      lapacke_ctr_trans.o \
      lapacke_dgb_nancheck.o \
      lapacke_dgb_trans.o \
      lapacke_dge_nancheck.o \
      lapacke_dge_trans.o \
      lapacke_dgg_nancheck.o \
      lapacke_dgg_trans.o \
      lapacke_dgt_nancheck.o \
      lapacke_dhs_nancheck.o \
      lapacke_dhs_trans.o \
      lapacke_d_nancheck.o \
      lapacke_dpb_nancheck.o \
      lapacke_dpb_trans.o \
      lapacke_dpf_nancheck.o \
      lapacke_dpf_trans.o \
      lapacke_dpo_nancheck.o \
      lapacke_dpo_trans.o \
      lapacke_dpp_nancheck.o \
      lapacke_dpp_trans.o \
      lapacke_dpt_nancheck.o \
      lapacke_dsb_nancheck.o \
      lapacke_dsb_trans.o \
      lapacke_dsp_nancheck.o \
      lapacke_dsp_trans.o \
      lapacke_dst_nancheck.o \
      lapacke_dsy_nancheck.o \
      lapacke_dsy_trans.o \
      lapacke_dtb_nancheck.o \
      lapacke_dtb_trans.o \
      lapacke_dtf_nancheck.o \
      lapacke_dtf_trans.o \
      lapacke_dtp_nancheck.o \
      lapacke_dtp_trans.o \
      lapacke_dtr_nancheck.o \
      lapacke_dtr_trans.o \
      lapacke_lsame.o \
      lapacke_sgb_nancheck.o \
      lapacke_sgb_trans.o \
      lapacke_sge_nancheck.o \
      lapacke_sge_trans.o \
      lapacke_sgg_nancheck.o \
      lapacke_sgg_trans.o \
      lapacke_sgt_nancheck.o \
      lapacke_shs_nancheck.o \
      lapacke_shs_trans.o \
      lapacke_s_nancheck.o \
      lapacke_spb_nancheck.o \
      lapacke_spb_trans.o \
      lapacke_spf_nancheck.o \
      lapacke_spf_trans.o \
      lapacke_spo_nancheck.o \
      lapacke_spo_trans.o \
      lapacke_spp_nancheck.o \
      lapacke_spp_trans.o \
      lapacke_spt_nancheck.o \
      lapacke_ssb_nancheck.o \
      lapacke_ssb_trans.o \
      lapacke_ssp_nancheck.o \
      lapacke_ssp_trans.o \
      lapacke_sst_nancheck.o \
      lapacke_ssy_nancheck.o \
      lapacke_ssy_trans.o \
      lapacke_stb_nancheck.o \
      lapacke_stb_trans.o \
      lapacke_stf_nancheck.o \
      lapacke_stf_trans.o \
      lapacke_stp_nancheck.o \
      lapacke_stp_trans.o \
      lapacke_str_nancheck.o \
      lapacke_str_trans.o \
      lapacke_xerbla.o \
      lapacke_zgb_nancheck.o \
      lapacke_zgb_trans.o \
      lapacke_zge_nancheck.o \
      lapacke_zge_trans.o \
      lapacke_zgg_nancheck.o \
      lapacke_zgg_trans.o \
      lapacke_zgt_nancheck.o \
      lapacke_zhb_nancheck.o \
      lapacke_zhb_trans.o \
      lapacke_zhe_nancheck.o \
      lapacke_zhe_trans.o \
      lapacke_zhp_nancheck.o \
      lapacke_zhp_trans.o \
      lapacke_zhs_nancheck.o \
      lapacke_zhs_trans.o \
      lapacke_z_nancheck.o \
      lapacke_zpb_nancheck.o \
      lapacke_zpb_trans.o \
      lapacke_zpf_nancheck.o \
      lapacke_zpf_trans.o \
      lapacke_zpo_nancheck.o \
      lapacke_zpo_trans.o \
      lapacke_zpp_nancheck.o \
      lapacke_zpp_trans.o \
      lapacke_zpt_nancheck.o \
      lapacke_zsp_nancheck.o \
      lapacke_zsp_trans.o \
      lapacke_zst_nancheck.o \
      lapacke_zsy_nancheck.o \
      lapacke_zsy_trans.o \
      lapacke_ztb_nancheck.o \
      lapacke_ztb_trans.o \
      lapacke_ztf_nancheck.o \
      lapacke_ztf_trans.o \
      lapacke_ztp_nancheck.o \
      lapacke_ztp_trans.o \
      lapacke_ztr_nancheck.o \
      lapacke_ztr_trans.o \
      lapacke_make_complex_float.o \
      lapacke_make_complex_double.o

all: lib

lib: $(OBJ)
	$(ARCH) $(ARCHFLAGS) ../../$(LAPACKELIB) $^
	$(RANLIB) ../../$(LAPACKELIB)

clean: cleanobj
cleanobj:
	rm -f *.o

.c.o:
	$(CC) $(CFLAGS) -I../include -c -o $@ $<

=== TESTING/EIG/CMakeLists.txt ===
########################################################################
#  This is the makefile for the eigenvalue test program from LAPACK.
#  The test files are organized as follows:
#
#     AEIGTST -- Auxiliary test routines used in all precisions
#     SCIGTST -- Auxiliary test routines used in single precision
#     DZIGTST -- Auxiliary test routines used in double precision
#     SEIGTST -- Single precision real test routines
#     CEIGTST -- Single precision complex test routines
#     DEIGTST -- Double precision real test routines
#     ZEIGTST -- Double precision complex test routines
#
########################################################################

set(AEIGTST
   alahdg.f
   alasum.f
   alasvm.f
   alareq.f
   ilaenv.f
   xerbla.f
   xlaenv.f
   chkxer.f)

set(SCIGTST slafts.f slahd2.f slasum.f slatb9.f sstech.f sstect.f
   ssvdch.f ssvdct.f ssxt1.f)

set(SEIGTST schkee.f
   sbdt01.f sbdt02.f sbdt03.f sbdt04.f sbdt05.f
   schkbb.f schkbd.f schkbk.f schkbl.f schkec.f
   schkgg.f schkgk.f schkgl.f schkhs.f schksb.f schkst.f schkst2stg.f schksb2stg.f
   sckcsd.f sckglm.f sckgqr.f sckgsv.f scklse.f scsdts.f
   sdrges.f sdrgev.f sdrges3.f sdrgev3.f sdrgsx.f sdrgvx.f
   sdrvbd.f sdrves.f sdrvev.f sdrvsg.f sdrvsg2stg.f
   sdrvst.f sdrvst2stg.f sdrvsx.f sdrvvx.f
   serrbd.f serrec.f serred.f serrgg.f serrhs.f serrst.f
   sget02.f sget10.f sget22.f sget23.f sget24.f sget31.f
   sget32.f sget33.f sget34.f sget35.f sget36.f
   sget37.f sget38.f sget39.f sget51.f sget52.f sget53.f
   sget54.f sglmts.f sgqrts.f sgrqts.f sgsvts3.f
   shst01.f slarfy.f slarhs.f slatm4.f slctes.f slctsx.f slsets.f sort01.f
   sort03.f ssbt21.f ssgt01.f sslect.f sspt21.f sstt21.f
   sstt22.f ssyt21.f ssyt22.f)

set(CEIGTST cchkee.f
   cbdt01.f cbdt02.f cbdt03.f cbdt05.f
   cchkbb.f cchkbd.f cchkbk.f cchkbl.f cchkec.f
   cchkgg.f cchkgk.f cchkgl.f cchkhb.f cchkhs.f cchkst.f cchkst2stg.f cchkhb2stg.f
   cckcsd.f cckglm.f cckgqr.f cckgsv.f ccklse.f ccsdts.f
   cdrges.f cdrgev.f cdrges3.f cdrgev3.f cdrgsx.f cdrgvx.f
   cdrvbd.f cdrves.f cdrvev.f cdrvsg.f cdrvsg2stg.f
   cdrvst.f cdrvst2stg.f cdrvsx.f cdrvvx.f
   cerrbd.f cerrec.f cerred.f cerrgg.f cerrhs.f cerrst.f
   cget02.f cget10.f cget22.f cget23.f cget24.f
   cget35.f cget36.f cget37.f cget38.f cget51.f cget52.f
   cget54.f cglmts.f cgqrts.f cgrqts.f cgsvts3.f
   chbt21.f chet21.f chet22.f chpt21.f chst01.f
   clarfy.f clarhs.f clatm4.f clctes.f clctsx.f clsets.f csbmv.f
   csgt01.f cslect.f
   cstt21.f cstt22.f cunt01.f cunt03.f)

set(DZIGTST dlafts.f dlahd2.f dlasum.f dlatb9.f dstech.f dstect.f
   dsvdch.f dsvdct.f dsxt1.f)

set(DEIGTST dchkee.f
   dbdt01.f dbdt02.f dbdt03.f dbdt04.f dbdt05.f
   dchkbb.f dchkbd.f dchkbk.f dchkbl.f dchkec.f
   dchkgg.f dchkgk.f dchkgl.f dchkhs.f dchksb.f dchkst.f dchkst2stg.f dchksb2stg.f
   dckcsd.f dckglm.f dckgqr.f dckgsv.f dcklse.f dcsdts.f
   ddrges.f ddrgev.f ddrges3.f ddrgev3.f ddrgsx.f ddrgvx.f
   ddrvbd.f ddrves.f ddrvev.f ddrvsg.f ddrvsg2stg.f
   ddrvst.f ddrvst2stg.f ddrvsx.f ddrvvx.f
   derrbd.f derrec.f derred.f derrgg.f derrhs.f derrst.f
   dget02.f dget10.f dget22.f dget23.f dget24.f dget31.f
   dget32.f dget33.f dget34.f dget35.f dget36.f
   dget37.f dget38.f dget39.f dget51.f dget52.f dget53.f
   dget54.f dglmts.f dgqrts.f dgrqts.f dgsvts3.f
   dhst01.f dlarfy.f dlarhs.f dlatm4.f dlctes.f dlctsx.f dlsets.f dort01.f
   dort03.f dsbt21.f dsgt01.f dslect.f dspt21.f dstt21.f
   dstt22.f dsyt21.f dsyt22.f)

set(ZEIGTST zchkee.f
   zbdt01.f zbdt02.f zbdt03.f zbdt05.f
   zchkbb.f zchkbd.f zchkbk.f zchkbl.f zchkec.f
   zchkgg.f zchkgk.f zchkgl.f zchkhb.f zchkhs.f zchkst.f zchkst2stg.f zchkhb2stg.f
   zckcsd.f zckglm.f zckgqr.f zckgsv.f zcklse.f zcsdts.f
   zdrges.f zdrgev.f zdrges3.f zdrgev3.f zdrgsx.f zdrgvx.f
   zdrvbd.f zdrves.f zdrvev.f zdrvsg.f zdrvsg2stg.f
   zdrvst.f zdrvst2stg.f zdrvsx.f zdrvvx.f
   zerrbd.f zerrec.f zerred.f zerrgg.f zerrhs.f zerrst.f
   zget02.f zget10.f zget22.f zget23.f zget24.f
   zget35.f zget36.f zget37.f zget38.f zget51.f zget52.f
   zget54.f zglmts.f zgqrts.f zgrqts.f zgsvts3.f
   zhbt21.f zhet21.f zhet22.f zhpt21.f zhst01.f
   zlarfy.f zlarhs.f zlatm4.f zlctes.f zlctsx.f zlsets.f zsbmv.f
   zsgt01.f zslect.f
   zstt21.f zstt22.f zunt01.f zunt03.f)

macro(add_eig_executable name)
  add_executable(${name} ${ARGN})
  target_link_libraries(${name} tmglib ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
endmacro()

if(BUILD_SINGLE)
add_eig_executable(xeigtsts ${SEIGTST} ${SCIGTST} ${AEIGTST})
endif()

if(BUILD_COMPLEX)
add_eig_executable(xeigtstc ${CEIGTST} ${SCIGTST} ${AEIGTST})
endif()

if(BUILD_DOUBLE)
add_eig_executable(xeigtstd ${DEIGTST} ${DZIGTST} ${AEIGTST})
endif()

if(BUILD_COMPLEX16)
add_eig_executable(xeigtstz ${ZEIGTST} ${DZIGTST} ${AEIGTST})
endif()

=== debian/changelog ===
lapack (3.7.1-4ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build with -O2 on ppc64el.
  * Dropped changes, included in Debian:
    - d/tests/lapack-testsuite: Depend on gcc, needed by dpkg-architecture.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 28 Nov 2017 11:24:00 -0800

lapack (3.7.1-4) unstable; urgency=low

  * Add gcc in the dependency list of {blas,lapack}-testsuite autopkgtests.
    This is needed by dpkg-architecture.
    Thanks to Matthias Klose (Closes: #875671)

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 13 Sep 2017 22:50:38 +0200

lapack (3.7.1-3ubuntu2) artful; urgency=medium

  * d/tests/lapack-testsuite: Depend on gcc, needed by dpkg-architecture.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 13 Sep 2017 08:49:00 +0200

lapack (3.7.1-3ubuntu1) artful; urgency=medium

  * Merge with Debian; remaining changes:
    - Build with -O2 on ppc64el.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 12 Sep 2017 10:36:32 +0200

lapack (3.7.1-3) unstable; urgency=low

  * Move dh-exec from Build-Depends-Arch to Build-Depends.
    Fixes FTBFS when building only arch:all packages.

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 09 Sep 2017 19:08:13 +0200

lapack (3.7.1-2) unstable; urgency=low

  [ Sébastien Villemot ]
  * Multi-archify the package.
    + drop package libblas-common, no longer needed
    + cblas.h is now included in the alternatives system (and installed under
      /usr/include/<multiarch>)
    + liblapack_pic.a is no longer in the alternatives system
    Thanks to Dima Kogan for his help (Closes: #770290)
  * d/control: remove unneeded dependency of liblapack-pic on liblapack3.
  * Drop the dependency of libblas-dev on gfortran. (Closes: #871967)
  * Bump packages from priority extra to optional, per policy 4.0.1.
  * Bump to Standards-Version 4.1.0.

  [ Dima Kogan ]
  * Using arch-specific compilers, binutils for cross-compiling.

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 09 Sep 2017 10:21:44 +0200

lapack (3.7.1-1ubuntu4) artful; urgency=medium

  * Build with -O2 on ppc64el.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 04 Aug 2017 14:34:54 -0400

lapack (3.7.1-1) unstable; urgency=medium

  * New upstream version 3.7.1
  * d/copyright:
    + Reflect upstream changes.
    + Use secure URL for format.
  * d/p/test-numbering.patch: drop patch, applied upstream.
  * d/p/fix-typos.patch: former patch applied upstream, but new typos detected
    by lintian, so update the patch.
  * Drop stub files in manpages and HTML documentation.
    - d/p/doxygen-downsize.patch: new patch, disable EXTRACT_ALL in Doxygen.
    - d/p/doxygen-strips-source.patch: drop patch, merge with the former.
    (Closes: #852166)
  * Drop transitional package libblas-doc.
  * Merge liblapack-doc-man into liblapack-doc.
    Now that both packages are smaller, it makes sense to merge them.
    liblapack-doc-man is now a transitional package.
  * Ship README.md in liblapack-doc.
  * d/watch: bump to format version 4.
  * d/rules: add support for "nodoc" tag of DEB_BUILD_OPTIONS.
  * d/control:
    + Use canonical URL for Vcs-Browser.
    + Remove unnecessary versioned build-dep on dpkg-dev.
    + Use the new Build-Depends-Arch field.
    + Bump to Standards-Version 4.0.0.
    + Drop obsolete Breaks against liblapack3gf.
    + Mark liblapack-doc{,-man} as M-A foreign.

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 04 Jul 2017 15:48:07 +0200

=== debian/control ===
Source: lapack
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 10),
               dh-exec
Build-Depends-Arch: gfortran,
                    python
Build-Depends-Indep: doxygen,
                     graphviz
Standards-Version: 4.1.0
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/lapack.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/lapack.git
Homepage: http://www.netlib.org/lapack/

Package: liblapack3
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libatlas3-base (<< 3.10.3-4~),
        libopenblas-base (<< 0.2.20+ds-3~),
        liblapack-dev (<< 3.7.1-2~)
Provides: liblapack.so.3
Description: Library of linear algebra routines 3 - shared version
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains a shared version of the library.

Package: liblapacke
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Provides: liblapacke.so.3
Description: Library of linear algebra routines 3 - C lib shared version
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains the Standard C language library for LAPACK.

Package: liblapacke-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         liblapacke (= ${binary:Version}),
         libblas-dev | libblas.so,
         liblapack-dev | liblapack.so,
         libtmglib-dev
Suggests: liblapack-doc
Description: Library of linear algebra routines 3 - Headers
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains development files for the C language library for LAPACK,
 including a static version of the library.

Package: libtmglib3
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: test matrix generators of LAPACK - shared version
 libtmglib is a component of the LAPACK library, containing routines for
 generation of input matrices for testing and timing of LAPACK.
 .
 This package contains a shared version of the library.

Package: libtmglib-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libtmglib3 (= ${binary:Version}),
         libblas-dev | libblas.so,
         liblapack-dev | liblapack.so
Description: test matrix generators of LAPACK - development files
 libtmglib is a component of the LAPACK library, containing routines for
 generation of input matrices for testing and timing of LAPACK.
 .
 This package contains development files, including a static version of the
 library.

Package: liblapack-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         liblapack3 (= ${binary:Version}),
         libblas-dev | libblas.so
Suggests: liblapack-doc
Breaks: libatlas-base-dev (<< 3.10.3-4~),
        libopenblas-dev (<< 0.2.20+ds-3~)
Provides: liblapack.so
Description: Library of linear algebra routines 3 - static version
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains a static version of the library.

Package: liblapack-pic
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}
Description: Library of linear algebra routines 3 - static PIC version
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 Normally one would want to use non-PIC code for static linking.  In
 this case, install liblapack-dev.  This package is provided for other
 packages, such as ATLAS, needing access to PIC versions of the lapack
 objects in their own build process.

Package: liblapack-test
Architecture: any
Multi-Arch: same
Section: devel
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: python
Description: Library of linear algebra routines 3 - testing programs
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 These testing programs have been run against the
 shared library in the lapack package.  The results have been
 collected in the files test_results.  These
 programs are provided separately here so that the user can
 test and compare alternate versions of the lapack libraries,
 such as those provided by the ATLAS packages, and the lapack
 package.

Package: liblapack-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Breaks: liblapack-doc-man (<< 3.7.1)
Replaces: liblapack-doc-man (<< 3.7.1)
Description: Library of linear algebra routines 3 - documentation
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains:
  - manpages of BLAS and LAPACK routines,
  - the Lapack User's Guide manual (in HTML),
  - the manual for the LAPACKE C interface to LAPACK (in PDF).

Package: libblas3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libatlas3-base (<< 3.10.3-4~),
        libopenblas-base (<< 0.2.20+ds-3~),
        libblas-dev (<< 3.7.1-2~)
Provides: libblas.so.3
Description: Basic Linear Algebra Reference implementations, shared library
 BLAS (Basic Linear Algebra Subroutines) is a set of efficient
 routines for most of the basic vector and matrix operations.
 They are widely used as the basis for other high quality linear
 algebra software, for example lapack and linpack.  This
 implementation is the Fortran 77 reference implementation found
 at netlib.
 .
 This package contains a shared version of the library.

Package: libblas-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libblas3 (= ${binary:Version}),
         ${misc:Depends}
Suggests: liblapack-doc
Breaks: libatlas-base-dev (<< 3.10.3-4~),
        libopenblas-dev (<< 0.2.20+ds-3~)
Provides: libblas.so
Description: Basic Linear Algebra Subroutines 3, static library
 This package is a binary incompatible upgrade to the blas-dev
 package. Several minor changes to the C interface have been
 incorporated.
 .
 BLAS (Basic Linear Algebra Subroutines) is a set of efficient
 routines for most of the basic vector and matrix operations.
 They are widely used as the basis for other high quality linear
 algebra software, for example lapack and linpack.  This
 implementation is the Fortran 77 reference implementation found
 at netlib.
 .
 This package contains a static version of the library.

Package: libblas-test
Architecture: any
Multi-Arch: same
Section: devel
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Basic Linear Algebra Subroutines 3, testing programs
 BLAS (Basic Linear Algebra Subroutines) is a set of efficient
 routines for most of the basic vector and matrix operations.
 They are widely used as the basis for other high quality linear
 algebra software, for example lapack and linpack.  This
 implementation is the Fortran 77 reference implementation found
 at netlib.
 .
 This package contains a set of programs which test the integrity of an
 installed blas-compatible shared library. These programs may therefore be used
 to test the libraries provided by the blas package as well as those provided
 by the libatlas3-base and libopenblas-base packages. The programs are
 dynamically linked -- one can explicitly select a library to test by setting
 the libblas.so.3 alternative, or by using the LD_LIBRARY_PATH or LD_PRELOAD
 environment variables. Likewise, one can display the library selected using
 the ldd program in an identical environment.

Package: liblapack-doc-man
Architecture: all
Multi-Arch: foreign
Section: oldlibs
Depends: ${misc:Depends},
         liblapack-doc
Description: Transitional package for BLAS and LAPACK manpages
 This is a transitional dummy package. It can be safely removed.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

SO:=3

# xerblas_ and LAPACK_xerblas must be overrideable by applications
# --dynamic-list does not work with gold, so drop the flag completely
BUILDFLAGS_ENV:=DEB_LDFLAGS_MAINT_STRIP="-Wl,-Bsymbolic-functions"
ifeq ($(DEB_HOST_ARCH),ppc64el)
BUILDFLAGS_ENV += DEB_CFLAGS_MAINT_STRIP="-O3" DEB_CFLAGS_MAINT_APPEND="-O2"
BUILDFLAGS_ENV += DEB_FFLAGS_MAINT_STRIP="-O3" DEB_FFLAGS_MAINT_APPEND="-O2"
endif

LDFLAGS:=$(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get LDFLAGS)

# if F77 isn't explicitly set (default or undefined), set it to the compiler for
# our host architecture. This may be a cross compiler
ifneq ($(filter default undefined,$(origin F77)),)
F77 := $(DEB_HOST_GNU_TYPE)-gfortran
endif

FFLAGS:=$(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get FFLAGS)
FFLAGS_NOOPT:=$(shell DEB_BUILD_OPTIONS=noopt $(BUILDFLAGS_ENV) dpkg-buildflags --get FFLAGS)

# if CC isn't explicitly set (default or undefined), set it to the compiler for
# our host architecture. This may be a cross compiler
ifneq ($(filter default undefined,$(origin CC)),)
CC := $(DEB_HOST_GNU_TYPE)-gcc
endif

CFLAGS:=$(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get CFLAGS)
CPPFLAGS:=$(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get CPPFLAGS)

ifeq ($(DEB_HOST_ARCH),alpha)
  FFLAGS += -mieee
  FFLAGS_NOOPT += -mieee
endif

# On arches with extended precision, this flag is used
# for BLAS when compiling i{c,z}amax.f and the BLAS testsuite,
# in order to avoid test failures.
# See also debian/patches/icamax-izamax-extended-precision.patch
ifneq (,$(filter $(DEB_HOST_ARCH_CPU),i386 m68k))
  FFLAGS_FLOAT_STORE := -ffloat-store
  export FFLAGS_FLOAT_STORE
endif

FFLAGS_BLAS_TESTSUITE := $(FFLAGS) $(FFLAGS_FLOAT_STORE)

# Using the -frecursive flag is the solution recommended by upstream for #693269
# However, we don't want to use -frecursive for the LAPACK testsuite, it leads to
#  segfaults on mips{,el} (xeigtstz allocates too much space on the stack)
FFLAGS_LAPACK_TESTSUITE := $(FFLAGS)
FFLAGS += -frecursive
FFLAGS_NOOPT += -frecursive

# Support parallel build
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

%:
	dh $@

make.inc: INSTALL/make.inc.gfortran
	sed -e "s,\(^CC  *=\).*,\1 $(CC),1" \
	    -e "s,\(^FORTRAN  *=\).*,\1 $(F77),1" \
	    -e "s,\(^NOOPT  *=\).*,\1 \$$(PICOPTS) $(FFLAGS_NOOPT),1" \
	    -e "s,\(^OPTS  *=\).*,\1 \$$(PICOPTS) $(FFLAGS),1" \
	    -e "s,\(^LOADER  *=\).*,\1 $(F77),1" \
	    -e "s/\(^LOADOPTS  *=\).*/\1 $(LDFLAGS)/1" \
	    -e "s,\(^ARCH  *=\).*,\1 $(DEB_HOST_GNU_TYPE)-ar,1" \
	    -e "s,\(^RANLIB  *=\).*,\1 $(DEB_HOST_GNU_TYPE)-ranlib,1" \
	    -e "s,\(^CFLAGS  *=\).*,\1 $(CPPFLAGS) \$$(PICOPTS) $(CFLAGS),1" \
	    < $< > $@
	# Build deprecated routines (see #810143)
	echo "BUILD_DEPRECATED=1" >> $@

override_dh_auto_clean: make.inc
	$(MAKE) clean
	rm -rf debian/*_stamp debian/*_results lib*.so* pic/
	rm -rf debian/test/ debian/time/
	rm -f TESTING/tmp TESTING/testing_results.txt
	rm -f LAPACKE/include/lapacke_mangling.h
	rm -f CBLAS/include/cblas_mangling.h
	rm -rf DOCS/explore-html/ DOCS/man/
	rm -f output_err
	rm -f lapack-netlib.pc LAPACKE/lapacke.pc BLAS/blas-netlib.pc
	rm -f make.inc

override_dh_auto_configure: make.inc
	# Create lapack-netlib.pc
	sed -e "s%@LAPACK_VERSION@%$(DEB_VERSION_UPSTREAM)%" \
	    -e "s%@CMAKE_INSTALL_FULL_INCLUDEDIR@%/usr/include/$(DEB_HOST_MULTIARCH)%"  \
	    -e "s%@CMAKE_INSTALL_FULL_LIBDIR@%/usr/lib/$(DEB_HOST_MULTIARCH)%" < lapack.pc.in > lapack-netlib.pc

	# Create lapacke.pc
	sed -e "s%@LAPACK_VERSION@%$(DEB_VERSION_UPSTREAM)%" \
	    -e "s%@CMAKE_INSTALL_FULL_INCLUDEDIR@%/usr/include/$(DEB_HOST_MULTIARCH)%"  \
	    -e "s%@CMAKE_INSTALL_FULL_LIBDIR@%/usr/lib/$(DEB_HOST_MULTIARCH)%" < LAPACKE/lapacke.pc.in > LAPACKE/lapacke.pc

	# Create blas-netlib.pc
	sed -e "s%@LAPACK_VERSION@%$(DEB_VERSION_UPSTREAM)%" \
	    -e "s%@CMAKE_INSTALL_FULL_INCLUDEDIR@%/usr/include/$(DEB_HOST_MULTIARCH)%"  \
	    -e "s%@CMAKE_INSTALL_FULL_LIBDIR@%/usr/lib/$(DEB_HOST_MULTIARCH)%" < BLAS/blas.pc.in > BLAS/blas-netlib.pc

override_dh_auto_build-arch:
	# Build pic libraries
	$(MAKE) cleanlib
	$(MAKE) blaslib cblaslib lapacklib tmglib lapackelib PICOPTS=-fPIC
	mkdir -p pic
	mv librefblas.a pic/librefblas_pic.a
	mv libcblas.a pic/libcblas_pic.a
	mv liblapack.a pic/liblapack_pic.a
	mv libtmglib.a pic/libtmglib_pic.a
	mv liblapacke.a pic/liblapacke_pic.a

	# Build libblas.so.*
	ar d pic/librefblas_pic.a xerbla.o # We want to use the xerbla.o from libcblas_pic.a
	mkdir -p tmp
	cd tmp && ar x ../pic/librefblas_pic.a && ar x ../pic/libcblas_pic.a
	$(F77) -shared -Wl,-soname=libblas.so.$(SO) -o libblas.so.$(DEB_VERSION_UPSTREAM) tmp/*.o $(LDFLAGS)
	rm -rf tmp
	ln -s libblas.so.$(DEB_VERSION_UPSTREAM) libblas.so.$(SO)
	ln -s libblas.so.$(DEB_VERSION_UPSTREAM) libblas.so

	# Build liblapack.so.*
	mkdir -p tmp
	cd tmp && ar x ../pic/liblapack_pic.a
	$(F77) -shared -Wl,-soname=liblapack.so.$(SO) -o liblapack.so.$(DEB_VERSION_UPSTREAM) tmp/*.o  -L. -lblas $(LDFLAGS)
	rm -rf tmp
	ln -s liblapack.so.$(DEB_VERSION_UPSTREAM) liblapack.so.$(SO)
	ln -s liblapack.so.$(DEB_VERSION_UPSTREAM) liblapack.so

	# Build libtmglib.so.*
	mkdir -p tmp
	cd tmp && ar x ../pic/libtmglib_pic.a
	$(F77) -shared -Wl,-soname=libtmglib.so.$(SO) -o libtmglib.so.$(DEB_VERSION_UPSTREAM) tmp/*.o  -L. -lblas -llapack $(LDFLAGS)
	rm -rf tmp
	ln -s libtmglib.so.$(DEB_VERSION_UPSTREAM) libtmglib.so.$(SO)
	ln -s libtmglib.so.$(DEB_VERSION_UPSTREAM) libtmglib.so

	# Build liblapacke.so.*
	mkdir -p tmp
	cd tmp && ar x ../pic/liblapacke_pic.a
	$(CC) -shared -Wl,-soname=liblapacke.so.$(SO) -o liblapacke.so.$(DEB_VERSION_UPSTREAM) tmp/*.o  -L. -lblas -llapack -ltmglib $(LDFLAGS)
	rm -rf tmp
	ln -s liblapacke.so.$(DEB_VERSION_UPSTREAM) liblapacke.so.$(SO)
	ln -s liblapacke.so.$(DEB_VERSION_UPSTREAM) liblapacke.so

	# Build static versions
	$(MAKE) cleanlib
	$(MAKE) blaslib cblaslib lapacklib tmglib lapackelib

	# Build libblas.a
	ar d librefblas.a xerbla.o # We want to use the xerbla.o from libcblas.a
	mkdir -p tmp
	cd tmp && ar x ../librefblas.a && ar x ../libcblas.a
	ar r libblas.a $$(env LC_ALL=C ls tmp/*.o)
	rm -rf tmp

	# Build the test programs, in order to avoid FTBFS if DEB_BUILD_OPTIONS contains nocheck
	$(MAKE) OPTS="$(FFLAGS_BLAS_TESTSUITE)" BLASLIB="../../libblas.so" -C BLAS/TESTING
	$(MAKE) OPTS="$(FFLAGS_BLAS_TESTSUITE)" BLASLIB="../../libblas.so" CBLASLIB="" -C CBLAS/testing
	$(MAKE) OPTS="$(FFLAGS_LAPACK_TESTSUITE)" BLASLIB="../../libblas.so" LAPACKLIB="liblapack.so" TMGLIB="libtmglib.so" -C TESTING EIG/xeigtstc EIG/xeigtstd EIG/xeigtsts EIG/xeigtstz LIN/xlintstc LIN/xlintstd LIN/xlintsts LIN/xlintstz LIN/xlintstds LIN/xlintstrfc LIN/xlintstrfd LIN/xlintstrfs LIN/xlintstrfz LIN/xlintstzc

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) html
	# Remove useless doxygen-generated files
	find DOCS/explore-html/ \( -name '*.map' -or -name '*.md5' \) -delete

	$(MAKE) man
	# Remove directory reference files, because they include local build pathnames
	# (but don't delete some __*__.3 files)
	rm DOCS/man/man3/_[a-zA-Z]*
endif

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Run BLAS tests, output the result, and stop if one test fails
	LD_LIBRARY_PATH=$$(pwd):$$LD_LIBRARY_PATH $(MAKE) blas_testing
	cat BLAS/TESTING/*.out
	! grep -q -i fail BLAS/TESTING/*.out

	# Run CBLAS tests, output the result, and stop if one test fails
	LD_LIBRARY_PATH=$$(pwd):$$LD_LIBRARY_PATH $(MAKE) cblas_testing
	cat CBLAS/testing/*.out
	! grep -q -i fail CBLAS/testing/*.out

	# Run LAPACK tests, but don't stop if one test fails
	# Only a summary is displayed; full test results in TESTING/testing_results.txt
	LD_LIBRARY_PATH=$$(pwd):$$LD_LIBRARY_PATH $(MAKE) lapack_testing
endif

override_dh_makeshlibs:
	dh_makeshlibs -pliblapack3 -V "liblapack3 | liblapack.so.3" -n

=== debian/watch ===
version=4
http://www.netlib.org/lapack/ lapack-([\d\.]+)\.tgz
